// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args13997 = [];
var len__7651__auto___14013 = arguments.length;
var i__7652__auto___14015 = (0);
while(true){
if((i__7652__auto___14015 < len__7651__auto___14013)){
args13997.push((arguments[i__7652__auto___14015]));

var G__14020 = (i__7652__auto___14015 + (1));
i__7652__auto___14015 = G__14020;
continue;
} else {
}
break;
}

var G__14001 = args13997.length;
switch (G__14001) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args13997.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async14003 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14003 = (function (f,blockable,meta14004){
this.f = f;
this.blockable = blockable;
this.meta14004 = meta14004;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14003.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14005,meta14004__$1){
var self__ = this;
var _14005__$1 = this;
return (new cljs.core.async.t_cljs$core$async14003(self__.f,self__.blockable,meta14004__$1));
});

cljs.core.async.t_cljs$core$async14003.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14005){
var self__ = this;
var _14005__$1 = this;
return self__.meta14004;
});

cljs.core.async.t_cljs$core$async14003.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14003.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async14003.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async14003.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async14003.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta14004","meta14004",-1518537917,null)], null);
});

cljs.core.async.t_cljs$core$async14003.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14003.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14003";

cljs.core.async.t_cljs$core$async14003.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14003");
});

cljs.core.async.__GT_t_cljs$core$async14003 = (function cljs$core$async$__GT_t_cljs$core$async14003(f__$1,blockable__$1,meta14004){
return (new cljs.core.async.t_cljs$core$async14003(f__$1,blockable__$1,meta14004));
});

}

return (new cljs.core.async.t_cljs$core$async14003(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args14047 = [];
var len__7651__auto___14055 = arguments.length;
var i__7652__auto___14057 = (0);
while(true){
if((i__7652__auto___14057 < len__7651__auto___14055)){
args14047.push((arguments[i__7652__auto___14057]));

var G__14059 = (i__7652__auto___14057 + (1));
i__7652__auto___14057 = G__14059;
continue;
} else {
}
break;
}

var G__14050 = args14047.length;
switch (G__14050) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14047.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str("buf-or-n")].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args14068 = [];
var len__7651__auto___14080 = arguments.length;
var i__7652__auto___14081 = (0);
while(true){
if((i__7652__auto___14081 < len__7651__auto___14080)){
args14068.push((arguments[i__7652__auto___14081]));

var G__14082 = (i__7652__auto___14081 + (1));
i__7652__auto___14081 = G__14082;
continue;
} else {
}
break;
}

var G__14073 = args14068.length;
switch (G__14073) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14068.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args14095 = [];
var len__7651__auto___14108 = arguments.length;
var i__7652__auto___14109 = (0);
while(true){
if((i__7652__auto___14109 < len__7651__auto___14108)){
args14095.push((arguments[i__7652__auto___14109]));

var G__14110 = (i__7652__auto___14109 + (1));
i__7652__auto___14109 = G__14110;
continue;
} else {
}
break;
}

var G__14104 = args14095.length;
switch (G__14104) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14095.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_14130 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_14130);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_14130,ret){
return (function (){
return fn1.call(null,val_14130);
});})(val_14130,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args14159 = [];
var len__7651__auto___14196 = arguments.length;
var i__7652__auto___14197 = (0);
while(true){
if((i__7652__auto___14197 < len__7651__auto___14196)){
args14159.push((arguments[i__7652__auto___14197]));

var G__14198 = (i__7652__auto___14197 + (1));
i__7652__auto___14197 = G__14198;
continue;
} else {
}
break;
}

var G__14173 = args14159.length;
switch (G__14173) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14159.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4655__auto__)){
var ret = temp__4655__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4655__auto__)){
var retb = temp__4655__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4655__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4655__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__7461__auto___14278 = n;
var x_14279 = (0);
while(true){
if((x_14279 < n__7461__auto___14278)){
(a[x_14279] = (0));

var G__14284 = (x_14279 + (1));
x_14279 = G__14284;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__14290 = (i + (1));
i = G__14290;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async14304 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14304 = (function (flag,meta14305){
this.flag = flag;
this.meta14305 = meta14305;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14304.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_14306,meta14305__$1){
var self__ = this;
var _14306__$1 = this;
return (new cljs.core.async.t_cljs$core$async14304(self__.flag,meta14305__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async14304.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_14306){
var self__ = this;
var _14306__$1 = this;
return self__.meta14305;
});})(flag))
;

cljs.core.async.t_cljs$core$async14304.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14304.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async14304.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async14304.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async14304.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta14305","meta14305",-1554499690,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async14304.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14304.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14304";

cljs.core.async.t_cljs$core$async14304.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14304");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async14304 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async14304(flag__$1,meta14305){
return (new cljs.core.async.t_cljs$core$async14304(flag__$1,meta14305));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async14304(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async14373 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14373 = (function (flag,cb,meta14374){
this.flag = flag;
this.cb = cb;
this.meta14374 = meta14374;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14373.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14375,meta14374__$1){
var self__ = this;
var _14375__$1 = this;
return (new cljs.core.async.t_cljs$core$async14373(self__.flag,self__.cb,meta14374__$1));
});

cljs.core.async.t_cljs$core$async14373.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14375){
var self__ = this;
var _14375__$1 = this;
return self__.meta14374;
});

cljs.core.async.t_cljs$core$async14373.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14373.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async14373.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async14373.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async14373.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta14374","meta14374",-1237630463,null)], null);
});

cljs.core.async.t_cljs$core$async14373.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14373.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14373";

cljs.core.async.t_cljs$core$async14373.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14373");
});

cljs.core.async.__GT_t_cljs$core$async14373 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async14373(flag__$1,cb__$1,meta14374){
return (new cljs.core.async.t_cljs$core$async14373(flag__$1,cb__$1,meta14374));
});

}

return (new cljs.core.async.t_cljs$core$async14373(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__14415_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__14415_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__14416_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__14416_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__6543__auto__ = wport;
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
return port;
}
})()], null));
} else {
var G__14503 = (i + (1));
i = G__14503;
continue;
}
} else {
return null;
}
break;
}
})();
var or__6543__auto__ = ret;
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4657__auto__ = (function (){var and__6531__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__6531__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__6531__auto__;
}
})();
if(cljs.core.truth_(temp__4657__auto__)){
var got = temp__4657__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__7658__auto__ = [];
var len__7651__auto___14538 = arguments.length;
var i__7652__auto___14539 = (0);
while(true){
if((i__7652__auto___14539 < len__7651__auto___14538)){
args__7658__auto__.push((arguments[i__7652__auto___14539]));

var G__14543 = (i__7652__auto___14539 + (1));
i__7652__auto___14539 = G__14543;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((1) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7659__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__14525){
var map__14526 = p__14525;
var map__14526__$1 = ((((!((map__14526 == null)))?((((map__14526.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__14526.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14526):map__14526);
var opts = map__14526__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq14507){
var G__14508 = cljs.core.first.call(null,seq14507);
var seq14507__$1 = cljs.core.next.call(null,seq14507);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__14508,seq14507__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args14559 = [];
var len__7651__auto___14642 = arguments.length;
var i__7652__auto___14643 = (0);
while(true){
if((i__7652__auto___14643 < len__7651__auto___14642)){
args14559.push((arguments[i__7652__auto___14643]));

var G__14644 = (i__7652__auto___14643 + (1));
i__7652__auto___14643 = G__14644;
continue;
} else {
}
break;
}

var G__14565 = args14559.length;
switch (G__14565) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14559.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__13836__auto___14649 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___14649){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___14649){
return (function (state_14605){
var state_val_14606 = (state_14605[(1)]);
if((state_val_14606 === (7))){
var inst_14601 = (state_14605[(2)]);
var state_14605__$1 = state_14605;
var statearr_14610_14656 = state_14605__$1;
(statearr_14610_14656[(2)] = inst_14601);

(statearr_14610_14656[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (1))){
var state_14605__$1 = state_14605;
var statearr_14611_14657 = state_14605__$1;
(statearr_14611_14657[(2)] = null);

(statearr_14611_14657[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (4))){
var inst_14584 = (state_14605[(7)]);
var inst_14584__$1 = (state_14605[(2)]);
var inst_14585 = (inst_14584__$1 == null);
var state_14605__$1 = (function (){var statearr_14612 = state_14605;
(statearr_14612[(7)] = inst_14584__$1);

return statearr_14612;
})();
if(cljs.core.truth_(inst_14585)){
var statearr_14613_14661 = state_14605__$1;
(statearr_14613_14661[(1)] = (5));

} else {
var statearr_14614_14662 = state_14605__$1;
(statearr_14614_14662[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (13))){
var state_14605__$1 = state_14605;
var statearr_14616_14665 = state_14605__$1;
(statearr_14616_14665[(2)] = null);

(statearr_14616_14665[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (6))){
var inst_14584 = (state_14605[(7)]);
var state_14605__$1 = state_14605;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14605__$1,(11),to,inst_14584);
} else {
if((state_val_14606 === (3))){
var inst_14603 = (state_14605[(2)]);
var state_14605__$1 = state_14605;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14605__$1,inst_14603);
} else {
if((state_val_14606 === (12))){
var state_14605__$1 = state_14605;
var statearr_14620_14669 = state_14605__$1;
(statearr_14620_14669[(2)] = null);

(statearr_14620_14669[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (2))){
var state_14605__$1 = state_14605;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14605__$1,(4),from);
} else {
if((state_val_14606 === (11))){
var inst_14594 = (state_14605[(2)]);
var state_14605__$1 = state_14605;
if(cljs.core.truth_(inst_14594)){
var statearr_14621_14674 = state_14605__$1;
(statearr_14621_14674[(1)] = (12));

} else {
var statearr_14623_14675 = state_14605__$1;
(statearr_14623_14675[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (9))){
var state_14605__$1 = state_14605;
var statearr_14624_14676 = state_14605__$1;
(statearr_14624_14676[(2)] = null);

(statearr_14624_14676[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (5))){
var state_14605__$1 = state_14605;
if(cljs.core.truth_(close_QMARK_)){
var statearr_14627_14677 = state_14605__$1;
(statearr_14627_14677[(1)] = (8));

} else {
var statearr_14628_14678 = state_14605__$1;
(statearr_14628_14678[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (14))){
var inst_14599 = (state_14605[(2)]);
var state_14605__$1 = state_14605;
var statearr_14629_14682 = state_14605__$1;
(statearr_14629_14682[(2)] = inst_14599);

(statearr_14629_14682[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (10))){
var inst_14591 = (state_14605[(2)]);
var state_14605__$1 = state_14605;
var statearr_14630_14687 = state_14605__$1;
(statearr_14630_14687[(2)] = inst_14591);

(statearr_14630_14687[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14606 === (8))){
var inst_14588 = cljs.core.async.close_BANG_.call(null,to);
var state_14605__$1 = state_14605;
var statearr_14631_14689 = state_14605__$1;
(statearr_14631_14689[(2)] = inst_14588);

(statearr_14631_14689[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___14649))
;
return ((function (switch__13813__auto__,c__13836__auto___14649){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_14637 = [null,null,null,null,null,null,null,null];
(statearr_14637[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_14637[(1)] = (1));

return statearr_14637;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_14605){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_14605);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e14638){if((e14638 instanceof Object)){
var ex__13817__auto__ = e14638;
var statearr_14639_14691 = state_14605;
(statearr_14639_14691[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14605);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14638;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14692 = state_14605;
state_14605 = G__14692;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_14605){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_14605);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___14649))
})();
var state__13838__auto__ = (function (){var statearr_14641 = f__13837__auto__.call(null);
(statearr_14641[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___14649);

return statearr_14641;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___14649))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__14916){
var vec__14917 = p__14916;
var v = cljs.core.nth.call(null,vec__14917,(0),null);
var p = cljs.core.nth.call(null,vec__14917,(1),null);
var job = vec__14917;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__13836__auto___15122 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___15122,res,vec__14917,v,p,job,jobs,results){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___15122,res,vec__14917,v,p,job,jobs,results){
return (function (state_14924){
var state_val_14925 = (state_14924[(1)]);
if((state_val_14925 === (1))){
var state_14924__$1 = state_14924;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14924__$1,(2),res,v);
} else {
if((state_val_14925 === (2))){
var inst_14921 = (state_14924[(2)]);
var inst_14922 = cljs.core.async.close_BANG_.call(null,res);
var state_14924__$1 = (function (){var statearr_14927 = state_14924;
(statearr_14927[(7)] = inst_14921);

return statearr_14927;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14924__$1,inst_14922);
} else {
return null;
}
}
});})(c__13836__auto___15122,res,vec__14917,v,p,job,jobs,results))
;
return ((function (switch__13813__auto__,c__13836__auto___15122,res,vec__14917,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0 = (function (){
var statearr_14933 = [null,null,null,null,null,null,null,null];
(statearr_14933[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__);

(statearr_14933[(1)] = (1));

return statearr_14933;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1 = (function (state_14924){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_14924);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e14934){if((e14934 instanceof Object)){
var ex__13817__auto__ = e14934;
var statearr_14935_15134 = state_14924;
(statearr_14935_15134[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14924);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14934;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15135 = state_14924;
state_14924 = G__15135;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = function(state_14924){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1.call(this,state_14924);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___15122,res,vec__14917,v,p,job,jobs,results))
})();
var state__13838__auto__ = (function (){var statearr_14936 = f__13837__auto__.call(null);
(statearr_14936[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___15122);

return statearr_14936;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___15122,res,vec__14917,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__14937){
var vec__14938 = p__14937;
var v = cljs.core.nth.call(null,vec__14938,(0),null);
var p = cljs.core.nth.call(null,vec__14938,(1),null);
var job = vec__14938;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__7461__auto___15139 = n;
var __15140 = (0);
while(true){
if((__15140 < n__7461__auto___15139)){
var G__14941_15141 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__14941_15141) {
case "compute":
var c__13836__auto___15143 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__15140,c__13836__auto___15143,G__14941_15141,n__7461__auto___15139,jobs,results,process,async){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (__15140,c__13836__auto___15143,G__14941_15141,n__7461__auto___15139,jobs,results,process,async){
return (function (state_14954){
var state_val_14955 = (state_14954[(1)]);
if((state_val_14955 === (1))){
var state_14954__$1 = state_14954;
var statearr_14956_15144 = state_14954__$1;
(statearr_14956_15144[(2)] = null);

(statearr_14956_15144[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14955 === (2))){
var state_14954__$1 = state_14954;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14954__$1,(4),jobs);
} else {
if((state_val_14955 === (3))){
var inst_14952 = (state_14954[(2)]);
var state_14954__$1 = state_14954;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14954__$1,inst_14952);
} else {
if((state_val_14955 === (4))){
var inst_14944 = (state_14954[(2)]);
var inst_14945 = process.call(null,inst_14944);
var state_14954__$1 = state_14954;
if(cljs.core.truth_(inst_14945)){
var statearr_14957_15145 = state_14954__$1;
(statearr_14957_15145[(1)] = (5));

} else {
var statearr_14958_15146 = state_14954__$1;
(statearr_14958_15146[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14955 === (5))){
var state_14954__$1 = state_14954;
var statearr_14959_15147 = state_14954__$1;
(statearr_14959_15147[(2)] = null);

(statearr_14959_15147[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14955 === (6))){
var state_14954__$1 = state_14954;
var statearr_14960_15148 = state_14954__$1;
(statearr_14960_15148[(2)] = null);

(statearr_14960_15148[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14955 === (7))){
var inst_14950 = (state_14954[(2)]);
var state_14954__$1 = state_14954;
var statearr_14961_15149 = state_14954__$1;
(statearr_14961_15149[(2)] = inst_14950);

(statearr_14961_15149[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__15140,c__13836__auto___15143,G__14941_15141,n__7461__auto___15139,jobs,results,process,async))
;
return ((function (__15140,switch__13813__auto__,c__13836__auto___15143,G__14941_15141,n__7461__auto___15139,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0 = (function (){
var statearr_14968 = [null,null,null,null,null,null,null];
(statearr_14968[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__);

(statearr_14968[(1)] = (1));

return statearr_14968;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1 = (function (state_14954){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_14954);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e14969){if((e14969 instanceof Object)){
var ex__13817__auto__ = e14969;
var statearr_14970_15152 = state_14954;
(statearr_14970_15152[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14954);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14969;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15153 = state_14954;
state_14954 = G__15153;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = function(state_14954){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1.call(this,state_14954);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__;
})()
;})(__15140,switch__13813__auto__,c__13836__auto___15143,G__14941_15141,n__7461__auto___15139,jobs,results,process,async))
})();
var state__13838__auto__ = (function (){var statearr_14971 = f__13837__auto__.call(null);
(statearr_14971[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___15143);

return statearr_14971;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(__15140,c__13836__auto___15143,G__14941_15141,n__7461__auto___15139,jobs,results,process,async))
);


break;
case "async":
var c__13836__auto___15154 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__15140,c__13836__auto___15154,G__14941_15141,n__7461__auto___15139,jobs,results,process,async){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (__15140,c__13836__auto___15154,G__14941_15141,n__7461__auto___15139,jobs,results,process,async){
return (function (state_14984){
var state_val_14985 = (state_14984[(1)]);
if((state_val_14985 === (1))){
var state_14984__$1 = state_14984;
var statearr_14986_15155 = state_14984__$1;
(statearr_14986_15155[(2)] = null);

(statearr_14986_15155[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14985 === (2))){
var state_14984__$1 = state_14984;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14984__$1,(4),jobs);
} else {
if((state_val_14985 === (3))){
var inst_14982 = (state_14984[(2)]);
var state_14984__$1 = state_14984;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14984__$1,inst_14982);
} else {
if((state_val_14985 === (4))){
var inst_14974 = (state_14984[(2)]);
var inst_14975 = async.call(null,inst_14974);
var state_14984__$1 = state_14984;
if(cljs.core.truth_(inst_14975)){
var statearr_14988_15156 = state_14984__$1;
(statearr_14988_15156[(1)] = (5));

} else {
var statearr_14989_15157 = state_14984__$1;
(statearr_14989_15157[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14985 === (5))){
var state_14984__$1 = state_14984;
var statearr_14991_15158 = state_14984__$1;
(statearr_14991_15158[(2)] = null);

(statearr_14991_15158[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14985 === (6))){
var state_14984__$1 = state_14984;
var statearr_14992_15159 = state_14984__$1;
(statearr_14992_15159[(2)] = null);

(statearr_14992_15159[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14985 === (7))){
var inst_14980 = (state_14984[(2)]);
var state_14984__$1 = state_14984;
var statearr_14993_15162 = state_14984__$1;
(statearr_14993_15162[(2)] = inst_14980);

(statearr_14993_15162[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__15140,c__13836__auto___15154,G__14941_15141,n__7461__auto___15139,jobs,results,process,async))
;
return ((function (__15140,switch__13813__auto__,c__13836__auto___15154,G__14941_15141,n__7461__auto___15139,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0 = (function (){
var statearr_14997 = [null,null,null,null,null,null,null];
(statearr_14997[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__);

(statearr_14997[(1)] = (1));

return statearr_14997;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1 = (function (state_14984){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_14984);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e14998){if((e14998 instanceof Object)){
var ex__13817__auto__ = e14998;
var statearr_14999_15168 = state_14984;
(statearr_14999_15168[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14984);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14998;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15170 = state_14984;
state_14984 = G__15170;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = function(state_14984){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1.call(this,state_14984);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__;
})()
;})(__15140,switch__13813__auto__,c__13836__auto___15154,G__14941_15141,n__7461__auto___15139,jobs,results,process,async))
})();
var state__13838__auto__ = (function (){var statearr_15000 = f__13837__auto__.call(null);
(statearr_15000[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___15154);

return statearr_15000;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(__15140,c__13836__auto___15154,G__14941_15141,n__7461__auto___15139,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__15171 = (__15140 + (1));
__15140 = G__15171;
continue;
} else {
}
break;
}

var c__13836__auto___15173 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___15173,jobs,results,process,async){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___15173,jobs,results,process,async){
return (function (state_15023){
var state_val_15024 = (state_15023[(1)]);
if((state_val_15024 === (1))){
var state_15023__$1 = state_15023;
var statearr_15025_15177 = state_15023__$1;
(statearr_15025_15177[(2)] = null);

(statearr_15025_15177[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15024 === (2))){
var state_15023__$1 = state_15023;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15023__$1,(4),from);
} else {
if((state_val_15024 === (3))){
var inst_15020 = (state_15023[(2)]);
var state_15023__$1 = state_15023;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15023__$1,inst_15020);
} else {
if((state_val_15024 === (4))){
var inst_15003 = (state_15023[(7)]);
var inst_15003__$1 = (state_15023[(2)]);
var inst_15004 = (inst_15003__$1 == null);
var state_15023__$1 = (function (){var statearr_15027 = state_15023;
(statearr_15027[(7)] = inst_15003__$1);

return statearr_15027;
})();
if(cljs.core.truth_(inst_15004)){
var statearr_15028_15181 = state_15023__$1;
(statearr_15028_15181[(1)] = (5));

} else {
var statearr_15029_15182 = state_15023__$1;
(statearr_15029_15182[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15024 === (5))){
var inst_15006 = cljs.core.async.close_BANG_.call(null,jobs);
var state_15023__$1 = state_15023;
var statearr_15031_15183 = state_15023__$1;
(statearr_15031_15183[(2)] = inst_15006);

(statearr_15031_15183[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15024 === (6))){
var inst_15003 = (state_15023[(7)]);
var inst_15008 = (state_15023[(8)]);
var inst_15008__$1 = cljs.core.async.chan.call(null,(1));
var inst_15009 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_15010 = [inst_15003,inst_15008__$1];
var inst_15011 = (new cljs.core.PersistentVector(null,2,(5),inst_15009,inst_15010,null));
var state_15023__$1 = (function (){var statearr_15032 = state_15023;
(statearr_15032[(8)] = inst_15008__$1);

return statearr_15032;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15023__$1,(8),jobs,inst_15011);
} else {
if((state_val_15024 === (7))){
var inst_15018 = (state_15023[(2)]);
var state_15023__$1 = state_15023;
var statearr_15033_15185 = state_15023__$1;
(statearr_15033_15185[(2)] = inst_15018);

(statearr_15033_15185[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15024 === (8))){
var inst_15008 = (state_15023[(8)]);
var inst_15013 = (state_15023[(2)]);
var state_15023__$1 = (function (){var statearr_15034 = state_15023;
(statearr_15034[(9)] = inst_15013);

return statearr_15034;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15023__$1,(9),results,inst_15008);
} else {
if((state_val_15024 === (9))){
var inst_15015 = (state_15023[(2)]);
var state_15023__$1 = (function (){var statearr_15035 = state_15023;
(statearr_15035[(10)] = inst_15015);

return statearr_15035;
})();
var statearr_15036_15186 = state_15023__$1;
(statearr_15036_15186[(2)] = null);

(statearr_15036_15186[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___15173,jobs,results,process,async))
;
return ((function (switch__13813__auto__,c__13836__auto___15173,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0 = (function (){
var statearr_15040 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_15040[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__);

(statearr_15040[(1)] = (1));

return statearr_15040;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1 = (function (state_15023){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_15023);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e15042){if((e15042 instanceof Object)){
var ex__13817__auto__ = e15042;
var statearr_15043_15187 = state_15023;
(statearr_15043_15187[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15023);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15042;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15188 = state_15023;
state_15023 = G__15188;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = function(state_15023){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1.call(this,state_15023);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___15173,jobs,results,process,async))
})();
var state__13838__auto__ = (function (){var statearr_15045 = f__13837__auto__.call(null);
(statearr_15045[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___15173);

return statearr_15045;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___15173,jobs,results,process,async))
);


var c__13836__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto__,jobs,results,process,async){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto__,jobs,results,process,async){
return (function (state_15085){
var state_val_15086 = (state_15085[(1)]);
if((state_val_15086 === (7))){
var inst_15079 = (state_15085[(2)]);
var state_15085__$1 = state_15085;
var statearr_15089_15190 = state_15085__$1;
(statearr_15089_15190[(2)] = inst_15079);

(statearr_15089_15190[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (20))){
var state_15085__$1 = state_15085;
var statearr_15090_15191 = state_15085__$1;
(statearr_15090_15191[(2)] = null);

(statearr_15090_15191[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (1))){
var state_15085__$1 = state_15085;
var statearr_15091_15192 = state_15085__$1;
(statearr_15091_15192[(2)] = null);

(statearr_15091_15192[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (4))){
var inst_15048 = (state_15085[(7)]);
var inst_15048__$1 = (state_15085[(2)]);
var inst_15049 = (inst_15048__$1 == null);
var state_15085__$1 = (function (){var statearr_15092 = state_15085;
(statearr_15092[(7)] = inst_15048__$1);

return statearr_15092;
})();
if(cljs.core.truth_(inst_15049)){
var statearr_15093_15193 = state_15085__$1;
(statearr_15093_15193[(1)] = (5));

} else {
var statearr_15094_15194 = state_15085__$1;
(statearr_15094_15194[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (15))){
var inst_15061 = (state_15085[(8)]);
var state_15085__$1 = state_15085;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15085__$1,(18),to,inst_15061);
} else {
if((state_val_15086 === (21))){
var inst_15074 = (state_15085[(2)]);
var state_15085__$1 = state_15085;
var statearr_15095_15196 = state_15085__$1;
(statearr_15095_15196[(2)] = inst_15074);

(statearr_15095_15196[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (13))){
var inst_15076 = (state_15085[(2)]);
var state_15085__$1 = (function (){var statearr_15096 = state_15085;
(statearr_15096[(9)] = inst_15076);

return statearr_15096;
})();
var statearr_15097_15197 = state_15085__$1;
(statearr_15097_15197[(2)] = null);

(statearr_15097_15197[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (6))){
var inst_15048 = (state_15085[(7)]);
var state_15085__$1 = state_15085;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15085__$1,(11),inst_15048);
} else {
if((state_val_15086 === (17))){
var inst_15069 = (state_15085[(2)]);
var state_15085__$1 = state_15085;
if(cljs.core.truth_(inst_15069)){
var statearr_15098_15198 = state_15085__$1;
(statearr_15098_15198[(1)] = (19));

} else {
var statearr_15099_15199 = state_15085__$1;
(statearr_15099_15199[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (3))){
var inst_15081 = (state_15085[(2)]);
var state_15085__$1 = state_15085;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15085__$1,inst_15081);
} else {
if((state_val_15086 === (12))){
var inst_15058 = (state_15085[(10)]);
var state_15085__$1 = state_15085;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15085__$1,(14),inst_15058);
} else {
if((state_val_15086 === (2))){
var state_15085__$1 = state_15085;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15085__$1,(4),results);
} else {
if((state_val_15086 === (19))){
var state_15085__$1 = state_15085;
var statearr_15100_15200 = state_15085__$1;
(statearr_15100_15200[(2)] = null);

(statearr_15100_15200[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (11))){
var inst_15058 = (state_15085[(2)]);
var state_15085__$1 = (function (){var statearr_15101 = state_15085;
(statearr_15101[(10)] = inst_15058);

return statearr_15101;
})();
var statearr_15103_15201 = state_15085__$1;
(statearr_15103_15201[(2)] = null);

(statearr_15103_15201[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (9))){
var state_15085__$1 = state_15085;
var statearr_15104_15202 = state_15085__$1;
(statearr_15104_15202[(2)] = null);

(statearr_15104_15202[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (5))){
var state_15085__$1 = state_15085;
if(cljs.core.truth_(close_QMARK_)){
var statearr_15105_15203 = state_15085__$1;
(statearr_15105_15203[(1)] = (8));

} else {
var statearr_15106_15204 = state_15085__$1;
(statearr_15106_15204[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (14))){
var inst_15061 = (state_15085[(8)]);
var inst_15063 = (state_15085[(11)]);
var inst_15061__$1 = (state_15085[(2)]);
var inst_15062 = (inst_15061__$1 == null);
var inst_15063__$1 = cljs.core.not.call(null,inst_15062);
var state_15085__$1 = (function (){var statearr_15107 = state_15085;
(statearr_15107[(8)] = inst_15061__$1);

(statearr_15107[(11)] = inst_15063__$1);

return statearr_15107;
})();
if(inst_15063__$1){
var statearr_15108_15205 = state_15085__$1;
(statearr_15108_15205[(1)] = (15));

} else {
var statearr_15109_15206 = state_15085__$1;
(statearr_15109_15206[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (16))){
var inst_15063 = (state_15085[(11)]);
var state_15085__$1 = state_15085;
var statearr_15111_15207 = state_15085__$1;
(statearr_15111_15207[(2)] = inst_15063);

(statearr_15111_15207[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (10))){
var inst_15055 = (state_15085[(2)]);
var state_15085__$1 = state_15085;
var statearr_15112_15213 = state_15085__$1;
(statearr_15112_15213[(2)] = inst_15055);

(statearr_15112_15213[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (18))){
var inst_15066 = (state_15085[(2)]);
var state_15085__$1 = state_15085;
var statearr_15113_15215 = state_15085__$1;
(statearr_15113_15215[(2)] = inst_15066);

(statearr_15113_15215[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15086 === (8))){
var inst_15052 = cljs.core.async.close_BANG_.call(null,to);
var state_15085__$1 = state_15085;
var statearr_15114_15216 = state_15085__$1;
(statearr_15114_15216[(2)] = inst_15052);

(statearr_15114_15216[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto__,jobs,results,process,async))
;
return ((function (switch__13813__auto__,c__13836__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0 = (function (){
var statearr_15118 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_15118[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__);

(statearr_15118[(1)] = (1));

return statearr_15118;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1 = (function (state_15085){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_15085);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e15119){if((e15119 instanceof Object)){
var ex__13817__auto__ = e15119;
var statearr_15120_15224 = state_15085;
(statearr_15120_15224[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15085);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15119;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15225 = state_15085;
state_15085 = G__15225;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__ = function(state_15085){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1.call(this,state_15085);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13814__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto__,jobs,results,process,async))
})();
var state__13838__auto__ = (function (){var statearr_15121 = f__13837__auto__.call(null);
(statearr_15121[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto__);

return statearr_15121;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto__,jobs,results,process,async))
);

return c__13836__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args15226 = [];
var len__7651__auto___15230 = arguments.length;
var i__7652__auto___15231 = (0);
while(true){
if((i__7652__auto___15231 < len__7651__auto___15230)){
args15226.push((arguments[i__7652__auto___15231]));

var G__15232 = (i__7652__auto___15231 + (1));
i__7652__auto___15231 = G__15232;
continue;
} else {
}
break;
}

var G__15229 = args15226.length;
switch (G__15229) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15226.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args15237 = [];
var len__7651__auto___15243 = arguments.length;
var i__7652__auto___15244 = (0);
while(true){
if((i__7652__auto___15244 < len__7651__auto___15243)){
args15237.push((arguments[i__7652__auto___15244]));

var G__15245 = (i__7652__auto___15244 + (1));
i__7652__auto___15244 = G__15245;
continue;
} else {
}
break;
}

var G__15242 = args15237.length;
switch (G__15242) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15237.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args15247 = [];
var len__7651__auto___15304 = arguments.length;
var i__7652__auto___15305 = (0);
while(true){
if((i__7652__auto___15305 < len__7651__auto___15304)){
args15247.push((arguments[i__7652__auto___15305]));

var G__15306 = (i__7652__auto___15305 + (1));
i__7652__auto___15305 = G__15306;
continue;
} else {
}
break;
}

var G__15249 = args15247.length;
switch (G__15249) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15247.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__13836__auto___15311 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___15311,tc,fc){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___15311,tc,fc){
return (function (state_15275){
var state_val_15276 = (state_15275[(1)]);
if((state_val_15276 === (7))){
var inst_15271 = (state_15275[(2)]);
var state_15275__$1 = state_15275;
var statearr_15277_15313 = state_15275__$1;
(statearr_15277_15313[(2)] = inst_15271);

(statearr_15277_15313[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (1))){
var state_15275__$1 = state_15275;
var statearr_15278_15315 = state_15275__$1;
(statearr_15278_15315[(2)] = null);

(statearr_15278_15315[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (4))){
var inst_15252 = (state_15275[(7)]);
var inst_15252__$1 = (state_15275[(2)]);
var inst_15253 = (inst_15252__$1 == null);
var state_15275__$1 = (function (){var statearr_15279 = state_15275;
(statearr_15279[(7)] = inst_15252__$1);

return statearr_15279;
})();
if(cljs.core.truth_(inst_15253)){
var statearr_15280_15319 = state_15275__$1;
(statearr_15280_15319[(1)] = (5));

} else {
var statearr_15281_15320 = state_15275__$1;
(statearr_15281_15320[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (13))){
var state_15275__$1 = state_15275;
var statearr_15282_15321 = state_15275__$1;
(statearr_15282_15321[(2)] = null);

(statearr_15282_15321[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (6))){
var inst_15252 = (state_15275[(7)]);
var inst_15258 = p.call(null,inst_15252);
var state_15275__$1 = state_15275;
if(cljs.core.truth_(inst_15258)){
var statearr_15283_15325 = state_15275__$1;
(statearr_15283_15325[(1)] = (9));

} else {
var statearr_15284_15327 = state_15275__$1;
(statearr_15284_15327[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (3))){
var inst_15273 = (state_15275[(2)]);
var state_15275__$1 = state_15275;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15275__$1,inst_15273);
} else {
if((state_val_15276 === (12))){
var state_15275__$1 = state_15275;
var statearr_15285_15328 = state_15275__$1;
(statearr_15285_15328[(2)] = null);

(statearr_15285_15328[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (2))){
var state_15275__$1 = state_15275;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15275__$1,(4),ch);
} else {
if((state_val_15276 === (11))){
var inst_15252 = (state_15275[(7)]);
var inst_15262 = (state_15275[(2)]);
var state_15275__$1 = state_15275;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15275__$1,(8),inst_15262,inst_15252);
} else {
if((state_val_15276 === (9))){
var state_15275__$1 = state_15275;
var statearr_15286_15329 = state_15275__$1;
(statearr_15286_15329[(2)] = tc);

(statearr_15286_15329[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (5))){
var inst_15255 = cljs.core.async.close_BANG_.call(null,tc);
var inst_15256 = cljs.core.async.close_BANG_.call(null,fc);
var state_15275__$1 = (function (){var statearr_15287 = state_15275;
(statearr_15287[(8)] = inst_15255);

return statearr_15287;
})();
var statearr_15288_15330 = state_15275__$1;
(statearr_15288_15330[(2)] = inst_15256);

(statearr_15288_15330[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (14))){
var inst_15269 = (state_15275[(2)]);
var state_15275__$1 = state_15275;
var statearr_15289_15331 = state_15275__$1;
(statearr_15289_15331[(2)] = inst_15269);

(statearr_15289_15331[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (10))){
var state_15275__$1 = state_15275;
var statearr_15290_15333 = state_15275__$1;
(statearr_15290_15333[(2)] = fc);

(statearr_15290_15333[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15276 === (8))){
var inst_15264 = (state_15275[(2)]);
var state_15275__$1 = state_15275;
if(cljs.core.truth_(inst_15264)){
var statearr_15291_15336 = state_15275__$1;
(statearr_15291_15336[(1)] = (12));

} else {
var statearr_15292_15340 = state_15275__$1;
(statearr_15292_15340[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___15311,tc,fc))
;
return ((function (switch__13813__auto__,c__13836__auto___15311,tc,fc){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_15299 = [null,null,null,null,null,null,null,null,null];
(statearr_15299[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_15299[(1)] = (1));

return statearr_15299;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_15275){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_15275);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e15300){if((e15300 instanceof Object)){
var ex__13817__auto__ = e15300;
var statearr_15302_15345 = state_15275;
(statearr_15302_15345[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15275);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15300;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15346 = state_15275;
state_15275 = G__15346;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_15275){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_15275);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___15311,tc,fc))
})();
var state__13838__auto__ = (function (){var statearr_15303 = f__13837__auto__.call(null);
(statearr_15303[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___15311);

return statearr_15303;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___15311,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__13836__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto__){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto__){
return (function (state_15419){
var state_val_15420 = (state_15419[(1)]);
if((state_val_15420 === (7))){
var inst_15415 = (state_15419[(2)]);
var state_15419__$1 = state_15419;
var statearr_15421_15446 = state_15419__$1;
(statearr_15421_15446[(2)] = inst_15415);

(statearr_15421_15446[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (1))){
var inst_15398 = init;
var state_15419__$1 = (function (){var statearr_15422 = state_15419;
(statearr_15422[(7)] = inst_15398);

return statearr_15422;
})();
var statearr_15423_15449 = state_15419__$1;
(statearr_15423_15449[(2)] = null);

(statearr_15423_15449[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (4))){
var inst_15402 = (state_15419[(8)]);
var inst_15402__$1 = (state_15419[(2)]);
var inst_15403 = (inst_15402__$1 == null);
var state_15419__$1 = (function (){var statearr_15424 = state_15419;
(statearr_15424[(8)] = inst_15402__$1);

return statearr_15424;
})();
if(cljs.core.truth_(inst_15403)){
var statearr_15425_15450 = state_15419__$1;
(statearr_15425_15450[(1)] = (5));

} else {
var statearr_15426_15454 = state_15419__$1;
(statearr_15426_15454[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (6))){
var inst_15398 = (state_15419[(7)]);
var inst_15406 = (state_15419[(9)]);
var inst_15402 = (state_15419[(8)]);
var inst_15406__$1 = f.call(null,inst_15398,inst_15402);
var inst_15407 = cljs.core.reduced_QMARK_.call(null,inst_15406__$1);
var state_15419__$1 = (function (){var statearr_15427 = state_15419;
(statearr_15427[(9)] = inst_15406__$1);

return statearr_15427;
})();
if(inst_15407){
var statearr_15428_15455 = state_15419__$1;
(statearr_15428_15455[(1)] = (8));

} else {
var statearr_15429_15456 = state_15419__$1;
(statearr_15429_15456[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (3))){
var inst_15417 = (state_15419[(2)]);
var state_15419__$1 = state_15419;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15419__$1,inst_15417);
} else {
if((state_val_15420 === (2))){
var state_15419__$1 = state_15419;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15419__$1,(4),ch);
} else {
if((state_val_15420 === (9))){
var inst_15406 = (state_15419[(9)]);
var inst_15398 = inst_15406;
var state_15419__$1 = (function (){var statearr_15430 = state_15419;
(statearr_15430[(7)] = inst_15398);

return statearr_15430;
})();
var statearr_15431_15457 = state_15419__$1;
(statearr_15431_15457[(2)] = null);

(statearr_15431_15457[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (5))){
var inst_15398 = (state_15419[(7)]);
var state_15419__$1 = state_15419;
var statearr_15432_15458 = state_15419__$1;
(statearr_15432_15458[(2)] = inst_15398);

(statearr_15432_15458[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (10))){
var inst_15413 = (state_15419[(2)]);
var state_15419__$1 = state_15419;
var statearr_15433_15459 = state_15419__$1;
(statearr_15433_15459[(2)] = inst_15413);

(statearr_15433_15459[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15420 === (8))){
var inst_15406 = (state_15419[(9)]);
var inst_15409 = cljs.core.deref.call(null,inst_15406);
var state_15419__$1 = state_15419;
var statearr_15434_15460 = state_15419__$1;
(statearr_15434_15460[(2)] = inst_15409);

(statearr_15434_15460[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto__))
;
return ((function (switch__13813__auto__,c__13836__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__13814__auto__ = null;
var cljs$core$async$reduce_$_state_machine__13814__auto____0 = (function (){
var statearr_15439 = [null,null,null,null,null,null,null,null,null,null];
(statearr_15439[(0)] = cljs$core$async$reduce_$_state_machine__13814__auto__);

(statearr_15439[(1)] = (1));

return statearr_15439;
});
var cljs$core$async$reduce_$_state_machine__13814__auto____1 = (function (state_15419){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_15419);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e15441){if((e15441 instanceof Object)){
var ex__13817__auto__ = e15441;
var statearr_15442_15473 = state_15419;
(statearr_15442_15473[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15419);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15441;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15474 = state_15419;
state_15419 = G__15474;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__13814__auto__ = function(state_15419){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__13814__auto____1.call(this,state_15419);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__13814__auto____0;
cljs$core$async$reduce_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__13814__auto____1;
return cljs$core$async$reduce_$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto__))
})();
var state__13838__auto__ = (function (){var statearr_15445 = f__13837__auto__.call(null);
(statearr_15445[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto__);

return statearr_15445;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto__))
);

return c__13836__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__13836__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto__,f__$1){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto__,f__$1){
return (function (state_15514){
var state_val_15515 = (state_15514[(1)]);
if((state_val_15515 === (1))){
var inst_15509 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_15514__$1 = state_15514;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15514__$1,(2),inst_15509);
} else {
if((state_val_15515 === (2))){
var inst_15511 = (state_15514[(2)]);
var inst_15512 = f__$1.call(null,inst_15511);
var state_15514__$1 = state_15514;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15514__$1,inst_15512);
} else {
return null;
}
}
});})(c__13836__auto__,f__$1))
;
return ((function (switch__13813__auto__,c__13836__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__13814__auto__ = null;
var cljs$core$async$transduce_$_state_machine__13814__auto____0 = (function (){
var statearr_15527 = [null,null,null,null,null,null,null];
(statearr_15527[(0)] = cljs$core$async$transduce_$_state_machine__13814__auto__);

(statearr_15527[(1)] = (1));

return statearr_15527;
});
var cljs$core$async$transduce_$_state_machine__13814__auto____1 = (function (state_15514){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_15514);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e15528){if((e15528 instanceof Object)){
var ex__13817__auto__ = e15528;
var statearr_15529_15571 = state_15514;
(statearr_15529_15571[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15514);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15528;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15574 = state_15514;
state_15514 = G__15574;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__13814__auto__ = function(state_15514){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__13814__auto____1.call(this,state_15514);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__13814__auto____0;
cljs$core$async$transduce_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__13814__auto____1;
return cljs$core$async$transduce_$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto__,f__$1))
})();
var state__13838__auto__ = (function (){var statearr_15535 = f__13837__auto__.call(null);
(statearr_15535[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto__);

return statearr_15535;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto__,f__$1))
);

return c__13836__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args15584 = [];
var len__7651__auto___15648 = arguments.length;
var i__7652__auto___15649 = (0);
while(true){
if((i__7652__auto___15649 < len__7651__auto___15648)){
args15584.push((arguments[i__7652__auto___15649]));

var G__15650 = (i__7652__auto___15649 + (1));
i__7652__auto___15649 = G__15650;
continue;
} else {
}
break;
}

var G__15592 = args15584.length;
switch (G__15592) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15584.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__13836__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto__){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto__){
return (function (state_15622){
var state_val_15623 = (state_15622[(1)]);
if((state_val_15623 === (7))){
var inst_15603 = (state_15622[(2)]);
var state_15622__$1 = state_15622;
var statearr_15625_15657 = state_15622__$1;
(statearr_15625_15657[(2)] = inst_15603);

(statearr_15625_15657[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (1))){
var inst_15597 = cljs.core.seq.call(null,coll);
var inst_15598 = inst_15597;
var state_15622__$1 = (function (){var statearr_15626 = state_15622;
(statearr_15626[(7)] = inst_15598);

return statearr_15626;
})();
var statearr_15627_15660 = state_15622__$1;
(statearr_15627_15660[(2)] = null);

(statearr_15627_15660[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (4))){
var inst_15598 = (state_15622[(7)]);
var inst_15601 = cljs.core.first.call(null,inst_15598);
var state_15622__$1 = state_15622;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15622__$1,(7),ch,inst_15601);
} else {
if((state_val_15623 === (13))){
var inst_15615 = (state_15622[(2)]);
var state_15622__$1 = state_15622;
var statearr_15628_15664 = state_15622__$1;
(statearr_15628_15664[(2)] = inst_15615);

(statearr_15628_15664[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (6))){
var inst_15606 = (state_15622[(2)]);
var state_15622__$1 = state_15622;
if(cljs.core.truth_(inst_15606)){
var statearr_15629_15665 = state_15622__$1;
(statearr_15629_15665[(1)] = (8));

} else {
var statearr_15630_15666 = state_15622__$1;
(statearr_15630_15666[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (3))){
var inst_15619 = (state_15622[(2)]);
var state_15622__$1 = state_15622;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15622__$1,inst_15619);
} else {
if((state_val_15623 === (12))){
var state_15622__$1 = state_15622;
var statearr_15631_15667 = state_15622__$1;
(statearr_15631_15667[(2)] = null);

(statearr_15631_15667[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (2))){
var inst_15598 = (state_15622[(7)]);
var state_15622__$1 = state_15622;
if(cljs.core.truth_(inst_15598)){
var statearr_15632_15669 = state_15622__$1;
(statearr_15632_15669[(1)] = (4));

} else {
var statearr_15633_15670 = state_15622__$1;
(statearr_15633_15670[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (11))){
var inst_15612 = cljs.core.async.close_BANG_.call(null,ch);
var state_15622__$1 = state_15622;
var statearr_15634_15671 = state_15622__$1;
(statearr_15634_15671[(2)] = inst_15612);

(statearr_15634_15671[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (9))){
var state_15622__$1 = state_15622;
if(cljs.core.truth_(close_QMARK_)){
var statearr_15635_15672 = state_15622__$1;
(statearr_15635_15672[(1)] = (11));

} else {
var statearr_15636_15673 = state_15622__$1;
(statearr_15636_15673[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (5))){
var inst_15598 = (state_15622[(7)]);
var state_15622__$1 = state_15622;
var statearr_15637_15674 = state_15622__$1;
(statearr_15637_15674[(2)] = inst_15598);

(statearr_15637_15674[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (10))){
var inst_15617 = (state_15622[(2)]);
var state_15622__$1 = state_15622;
var statearr_15638_15675 = state_15622__$1;
(statearr_15638_15675[(2)] = inst_15617);

(statearr_15638_15675[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15623 === (8))){
var inst_15598 = (state_15622[(7)]);
var inst_15608 = cljs.core.next.call(null,inst_15598);
var inst_15598__$1 = inst_15608;
var state_15622__$1 = (function (){var statearr_15639 = state_15622;
(statearr_15639[(7)] = inst_15598__$1);

return statearr_15639;
})();
var statearr_15640_15678 = state_15622__$1;
(statearr_15640_15678[(2)] = null);

(statearr_15640_15678[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto__))
;
return ((function (switch__13813__auto__,c__13836__auto__){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_15644 = [null,null,null,null,null,null,null,null];
(statearr_15644[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_15644[(1)] = (1));

return statearr_15644;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_15622){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_15622);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e15645){if((e15645 instanceof Object)){
var ex__13817__auto__ = e15645;
var statearr_15646_15684 = state_15622;
(statearr_15646_15684[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15622);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15645;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15687 = state_15622;
state_15622 = G__15687;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_15622){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_15622);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto__))
})();
var state__13838__auto__ = (function (){var statearr_15647 = f__13837__auto__.call(null);
(statearr_15647[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto__);

return statearr_15647;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto__))
);

return c__13836__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__7206__auto__ = (((_ == null))?null:_);
var m__7207__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,_);
} else {
var m__7207__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__7207__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m);
} else {
var m__7207__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async16042 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16042 = (function (ch,cs,meta16043){
this.ch = ch;
this.cs = cs;
this.meta16043 = meta16043;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_16044,meta16043__$1){
var self__ = this;
var _16044__$1 = this;
return (new cljs.core.async.t_cljs$core$async16042(self__.ch,self__.cs,meta16043__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_16044){
var self__ = this;
var _16044__$1 = this;
return self__.meta16043;
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta16043","meta16043",63718003,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async16042.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16042.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16042";

cljs.core.async.t_cljs$core$async16042.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16042");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async16042 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async16042(ch__$1,cs__$1,meta16043){
return (new cljs.core.async.t_cljs$core$async16042(ch__$1,cs__$1,meta16043));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async16042(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__13836__auto___16305 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___16305,cs,m,dchan,dctr,done){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___16305,cs,m,dchan,dctr,done){
return (function (state_16192){
var state_val_16193 = (state_16192[(1)]);
if((state_val_16193 === (7))){
var inst_16185 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16194_16306 = state_16192__$1;
(statearr_16194_16306[(2)] = inst_16185);

(statearr_16194_16306[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (20))){
var inst_16084 = (state_16192[(7)]);
var inst_16096 = cljs.core.first.call(null,inst_16084);
var inst_16097 = cljs.core.nth.call(null,inst_16096,(0),null);
var inst_16098 = cljs.core.nth.call(null,inst_16096,(1),null);
var state_16192__$1 = (function (){var statearr_16198 = state_16192;
(statearr_16198[(8)] = inst_16097);

return statearr_16198;
})();
if(cljs.core.truth_(inst_16098)){
var statearr_16199_16307 = state_16192__$1;
(statearr_16199_16307[(1)] = (22));

} else {
var statearr_16200_16308 = state_16192__$1;
(statearr_16200_16308[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (27))){
var inst_16053 = (state_16192[(9)]);
var inst_16126 = (state_16192[(10)]);
var inst_16128 = (state_16192[(11)]);
var inst_16133 = (state_16192[(12)]);
var inst_16133__$1 = cljs.core._nth.call(null,inst_16126,inst_16128);
var inst_16135 = cljs.core.async.put_BANG_.call(null,inst_16133__$1,inst_16053,done);
var state_16192__$1 = (function (){var statearr_16201 = state_16192;
(statearr_16201[(12)] = inst_16133__$1);

return statearr_16201;
})();
if(cljs.core.truth_(inst_16135)){
var statearr_16202_16314 = state_16192__$1;
(statearr_16202_16314[(1)] = (30));

} else {
var statearr_16203_16318 = state_16192__$1;
(statearr_16203_16318[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (1))){
var state_16192__$1 = state_16192;
var statearr_16204_16323 = state_16192__$1;
(statearr_16204_16323[(2)] = null);

(statearr_16204_16323[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (24))){
var inst_16084 = (state_16192[(7)]);
var inst_16103 = (state_16192[(2)]);
var inst_16104 = cljs.core.next.call(null,inst_16084);
var inst_16062 = inst_16104;
var inst_16063 = null;
var inst_16064 = (0);
var inst_16065 = (0);
var state_16192__$1 = (function (){var statearr_16205 = state_16192;
(statearr_16205[(13)] = inst_16062);

(statearr_16205[(14)] = inst_16103);

(statearr_16205[(15)] = inst_16063);

(statearr_16205[(16)] = inst_16065);

(statearr_16205[(17)] = inst_16064);

return statearr_16205;
})();
var statearr_16206_16328 = state_16192__$1;
(statearr_16206_16328[(2)] = null);

(statearr_16206_16328[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (39))){
var state_16192__$1 = state_16192;
var statearr_16210_16335 = state_16192__$1;
(statearr_16210_16335[(2)] = null);

(statearr_16210_16335[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (4))){
var inst_16053 = (state_16192[(9)]);
var inst_16053__$1 = (state_16192[(2)]);
var inst_16054 = (inst_16053__$1 == null);
var state_16192__$1 = (function (){var statearr_16211 = state_16192;
(statearr_16211[(9)] = inst_16053__$1);

return statearr_16211;
})();
if(cljs.core.truth_(inst_16054)){
var statearr_16212_16336 = state_16192__$1;
(statearr_16212_16336[(1)] = (5));

} else {
var statearr_16213_16337 = state_16192__$1;
(statearr_16213_16337[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (15))){
var inst_16062 = (state_16192[(13)]);
var inst_16063 = (state_16192[(15)]);
var inst_16065 = (state_16192[(16)]);
var inst_16064 = (state_16192[(17)]);
var inst_16080 = (state_16192[(2)]);
var inst_16081 = (inst_16065 + (1));
var tmp16207 = inst_16062;
var tmp16208 = inst_16063;
var tmp16209 = inst_16064;
var inst_16062__$1 = tmp16207;
var inst_16063__$1 = tmp16208;
var inst_16064__$1 = tmp16209;
var inst_16065__$1 = inst_16081;
var state_16192__$1 = (function (){var statearr_16214 = state_16192;
(statearr_16214[(13)] = inst_16062__$1);

(statearr_16214[(18)] = inst_16080);

(statearr_16214[(15)] = inst_16063__$1);

(statearr_16214[(16)] = inst_16065__$1);

(statearr_16214[(17)] = inst_16064__$1);

return statearr_16214;
})();
var statearr_16215_16341 = state_16192__$1;
(statearr_16215_16341[(2)] = null);

(statearr_16215_16341[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (21))){
var inst_16107 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16219_16342 = state_16192__$1;
(statearr_16219_16342[(2)] = inst_16107);

(statearr_16219_16342[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (31))){
var inst_16133 = (state_16192[(12)]);
var inst_16138 = done.call(null,null);
var inst_16139 = cljs.core.async.untap_STAR_.call(null,m,inst_16133);
var state_16192__$1 = (function (){var statearr_16222 = state_16192;
(statearr_16222[(19)] = inst_16138);

return statearr_16222;
})();
var statearr_16224_16343 = state_16192__$1;
(statearr_16224_16343[(2)] = inst_16139);

(statearr_16224_16343[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (32))){
var inst_16125 = (state_16192[(20)]);
var inst_16126 = (state_16192[(10)]);
var inst_16128 = (state_16192[(11)]);
var inst_16127 = (state_16192[(21)]);
var inst_16141 = (state_16192[(2)]);
var inst_16144 = (inst_16128 + (1));
var tmp16216 = inst_16125;
var tmp16217 = inst_16126;
var tmp16218 = inst_16127;
var inst_16125__$1 = tmp16216;
var inst_16126__$1 = tmp16217;
var inst_16127__$1 = tmp16218;
var inst_16128__$1 = inst_16144;
var state_16192__$1 = (function (){var statearr_16225 = state_16192;
(statearr_16225[(20)] = inst_16125__$1);

(statearr_16225[(10)] = inst_16126__$1);

(statearr_16225[(11)] = inst_16128__$1);

(statearr_16225[(22)] = inst_16141);

(statearr_16225[(21)] = inst_16127__$1);

return statearr_16225;
})();
var statearr_16226_16347 = state_16192__$1;
(statearr_16226_16347[(2)] = null);

(statearr_16226_16347[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (40))){
var inst_16157 = (state_16192[(23)]);
var inst_16161 = done.call(null,null);
var inst_16162 = cljs.core.async.untap_STAR_.call(null,m,inst_16157);
var state_16192__$1 = (function (){var statearr_16227 = state_16192;
(statearr_16227[(24)] = inst_16161);

return statearr_16227;
})();
var statearr_16228_16352 = state_16192__$1;
(statearr_16228_16352[(2)] = inst_16162);

(statearr_16228_16352[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (33))){
var inst_16148 = (state_16192[(25)]);
var inst_16150 = cljs.core.chunked_seq_QMARK_.call(null,inst_16148);
var state_16192__$1 = state_16192;
if(inst_16150){
var statearr_16229_16353 = state_16192__$1;
(statearr_16229_16353[(1)] = (36));

} else {
var statearr_16230_16354 = state_16192__$1;
(statearr_16230_16354[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (13))){
var inst_16074 = (state_16192[(26)]);
var inst_16077 = cljs.core.async.close_BANG_.call(null,inst_16074);
var state_16192__$1 = state_16192;
var statearr_16231_16355 = state_16192__$1;
(statearr_16231_16355[(2)] = inst_16077);

(statearr_16231_16355[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (22))){
var inst_16097 = (state_16192[(8)]);
var inst_16100 = cljs.core.async.close_BANG_.call(null,inst_16097);
var state_16192__$1 = state_16192;
var statearr_16232_16356 = state_16192__$1;
(statearr_16232_16356[(2)] = inst_16100);

(statearr_16232_16356[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (36))){
var inst_16148 = (state_16192[(25)]);
var inst_16152 = cljs.core.chunk_first.call(null,inst_16148);
var inst_16153 = cljs.core.chunk_rest.call(null,inst_16148);
var inst_16154 = cljs.core.count.call(null,inst_16152);
var inst_16125 = inst_16153;
var inst_16126 = inst_16152;
var inst_16127 = inst_16154;
var inst_16128 = (0);
var state_16192__$1 = (function (){var statearr_16236 = state_16192;
(statearr_16236[(20)] = inst_16125);

(statearr_16236[(10)] = inst_16126);

(statearr_16236[(11)] = inst_16128);

(statearr_16236[(21)] = inst_16127);

return statearr_16236;
})();
var statearr_16237_16357 = state_16192__$1;
(statearr_16237_16357[(2)] = null);

(statearr_16237_16357[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (41))){
var inst_16148 = (state_16192[(25)]);
var inst_16164 = (state_16192[(2)]);
var inst_16165 = cljs.core.next.call(null,inst_16148);
var inst_16125 = inst_16165;
var inst_16126 = null;
var inst_16127 = (0);
var inst_16128 = (0);
var state_16192__$1 = (function (){var statearr_16238 = state_16192;
(statearr_16238[(20)] = inst_16125);

(statearr_16238[(27)] = inst_16164);

(statearr_16238[(10)] = inst_16126);

(statearr_16238[(11)] = inst_16128);

(statearr_16238[(21)] = inst_16127);

return statearr_16238;
})();
var statearr_16239_16361 = state_16192__$1;
(statearr_16239_16361[(2)] = null);

(statearr_16239_16361[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (43))){
var state_16192__$1 = state_16192;
var statearr_16240_16366 = state_16192__$1;
(statearr_16240_16366[(2)] = null);

(statearr_16240_16366[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (29))){
var inst_16173 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16241_16371 = state_16192__$1;
(statearr_16241_16371[(2)] = inst_16173);

(statearr_16241_16371[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (44))){
var inst_16182 = (state_16192[(2)]);
var state_16192__$1 = (function (){var statearr_16242 = state_16192;
(statearr_16242[(28)] = inst_16182);

return statearr_16242;
})();
var statearr_16243_16376 = state_16192__$1;
(statearr_16243_16376[(2)] = null);

(statearr_16243_16376[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (6))){
var inst_16117 = (state_16192[(29)]);
var inst_16116 = cljs.core.deref.call(null,cs);
var inst_16117__$1 = cljs.core.keys.call(null,inst_16116);
var inst_16118 = cljs.core.count.call(null,inst_16117__$1);
var inst_16119 = cljs.core.reset_BANG_.call(null,dctr,inst_16118);
var inst_16124 = cljs.core.seq.call(null,inst_16117__$1);
var inst_16125 = inst_16124;
var inst_16126 = null;
var inst_16127 = (0);
var inst_16128 = (0);
var state_16192__$1 = (function (){var statearr_16244 = state_16192;
(statearr_16244[(20)] = inst_16125);

(statearr_16244[(29)] = inst_16117__$1);

(statearr_16244[(30)] = inst_16119);

(statearr_16244[(10)] = inst_16126);

(statearr_16244[(11)] = inst_16128);

(statearr_16244[(21)] = inst_16127);

return statearr_16244;
})();
var statearr_16245_16377 = state_16192__$1;
(statearr_16245_16377[(2)] = null);

(statearr_16245_16377[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (28))){
var inst_16125 = (state_16192[(20)]);
var inst_16148 = (state_16192[(25)]);
var inst_16148__$1 = cljs.core.seq.call(null,inst_16125);
var state_16192__$1 = (function (){var statearr_16248 = state_16192;
(statearr_16248[(25)] = inst_16148__$1);

return statearr_16248;
})();
if(inst_16148__$1){
var statearr_16249_16378 = state_16192__$1;
(statearr_16249_16378[(1)] = (33));

} else {
var statearr_16250_16379 = state_16192__$1;
(statearr_16250_16379[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (25))){
var inst_16128 = (state_16192[(11)]);
var inst_16127 = (state_16192[(21)]);
var inst_16130 = (inst_16128 < inst_16127);
var inst_16131 = inst_16130;
var state_16192__$1 = state_16192;
if(cljs.core.truth_(inst_16131)){
var statearr_16251_16381 = state_16192__$1;
(statearr_16251_16381[(1)] = (27));

} else {
var statearr_16252_16383 = state_16192__$1;
(statearr_16252_16383[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (34))){
var state_16192__$1 = state_16192;
var statearr_16253_16384 = state_16192__$1;
(statearr_16253_16384[(2)] = null);

(statearr_16253_16384[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (17))){
var state_16192__$1 = state_16192;
var statearr_16254_16385 = state_16192__$1;
(statearr_16254_16385[(2)] = null);

(statearr_16254_16385[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (3))){
var inst_16187 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16192__$1,inst_16187);
} else {
if((state_val_16193 === (12))){
var inst_16112 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16256_16388 = state_16192__$1;
(statearr_16256_16388[(2)] = inst_16112);

(statearr_16256_16388[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (2))){
var state_16192__$1 = state_16192;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16192__$1,(4),ch);
} else {
if((state_val_16193 === (23))){
var state_16192__$1 = state_16192;
var statearr_16257_16391 = state_16192__$1;
(statearr_16257_16391[(2)] = null);

(statearr_16257_16391[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (35))){
var inst_16171 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16258_16392 = state_16192__$1;
(statearr_16258_16392[(2)] = inst_16171);

(statearr_16258_16392[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (19))){
var inst_16084 = (state_16192[(7)]);
var inst_16088 = cljs.core.chunk_first.call(null,inst_16084);
var inst_16089 = cljs.core.chunk_rest.call(null,inst_16084);
var inst_16090 = cljs.core.count.call(null,inst_16088);
var inst_16062 = inst_16089;
var inst_16063 = inst_16088;
var inst_16064 = inst_16090;
var inst_16065 = (0);
var state_16192__$1 = (function (){var statearr_16259 = state_16192;
(statearr_16259[(13)] = inst_16062);

(statearr_16259[(15)] = inst_16063);

(statearr_16259[(16)] = inst_16065);

(statearr_16259[(17)] = inst_16064);

return statearr_16259;
})();
var statearr_16260_16393 = state_16192__$1;
(statearr_16260_16393[(2)] = null);

(statearr_16260_16393[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (11))){
var inst_16062 = (state_16192[(13)]);
var inst_16084 = (state_16192[(7)]);
var inst_16084__$1 = cljs.core.seq.call(null,inst_16062);
var state_16192__$1 = (function (){var statearr_16261 = state_16192;
(statearr_16261[(7)] = inst_16084__$1);

return statearr_16261;
})();
if(inst_16084__$1){
var statearr_16262_16394 = state_16192__$1;
(statearr_16262_16394[(1)] = (16));

} else {
var statearr_16263_16395 = state_16192__$1;
(statearr_16263_16395[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (9))){
var inst_16114 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16264_16397 = state_16192__$1;
(statearr_16264_16397[(2)] = inst_16114);

(statearr_16264_16397[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (5))){
var inst_16060 = cljs.core.deref.call(null,cs);
var inst_16061 = cljs.core.seq.call(null,inst_16060);
var inst_16062 = inst_16061;
var inst_16063 = null;
var inst_16064 = (0);
var inst_16065 = (0);
var state_16192__$1 = (function (){var statearr_16268 = state_16192;
(statearr_16268[(13)] = inst_16062);

(statearr_16268[(15)] = inst_16063);

(statearr_16268[(16)] = inst_16065);

(statearr_16268[(17)] = inst_16064);

return statearr_16268;
})();
var statearr_16269_16400 = state_16192__$1;
(statearr_16269_16400[(2)] = null);

(statearr_16269_16400[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (14))){
var state_16192__$1 = state_16192;
var statearr_16270_16402 = state_16192__$1;
(statearr_16270_16402[(2)] = null);

(statearr_16270_16402[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (45))){
var inst_16179 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16271_16405 = state_16192__$1;
(statearr_16271_16405[(2)] = inst_16179);

(statearr_16271_16405[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (26))){
var inst_16117 = (state_16192[(29)]);
var inst_16175 = (state_16192[(2)]);
var inst_16176 = cljs.core.seq.call(null,inst_16117);
var state_16192__$1 = (function (){var statearr_16272 = state_16192;
(statearr_16272[(31)] = inst_16175);

return statearr_16272;
})();
if(inst_16176){
var statearr_16273_16408 = state_16192__$1;
(statearr_16273_16408[(1)] = (42));

} else {
var statearr_16274_16411 = state_16192__$1;
(statearr_16274_16411[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (16))){
var inst_16084 = (state_16192[(7)]);
var inst_16086 = cljs.core.chunked_seq_QMARK_.call(null,inst_16084);
var state_16192__$1 = state_16192;
if(inst_16086){
var statearr_16275_16412 = state_16192__$1;
(statearr_16275_16412[(1)] = (19));

} else {
var statearr_16276_16413 = state_16192__$1;
(statearr_16276_16413[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (38))){
var inst_16168 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16277_16430 = state_16192__$1;
(statearr_16277_16430[(2)] = inst_16168);

(statearr_16277_16430[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (30))){
var state_16192__$1 = state_16192;
var statearr_16278_16436 = state_16192__$1;
(statearr_16278_16436[(2)] = null);

(statearr_16278_16436[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (10))){
var inst_16063 = (state_16192[(15)]);
var inst_16065 = (state_16192[(16)]);
var inst_16073 = cljs.core._nth.call(null,inst_16063,inst_16065);
var inst_16074 = cljs.core.nth.call(null,inst_16073,(0),null);
var inst_16075 = cljs.core.nth.call(null,inst_16073,(1),null);
var state_16192__$1 = (function (){var statearr_16280 = state_16192;
(statearr_16280[(26)] = inst_16074);

return statearr_16280;
})();
if(cljs.core.truth_(inst_16075)){
var statearr_16282_16445 = state_16192__$1;
(statearr_16282_16445[(1)] = (13));

} else {
var statearr_16284_16446 = state_16192__$1;
(statearr_16284_16446[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (18))){
var inst_16110 = (state_16192[(2)]);
var state_16192__$1 = state_16192;
var statearr_16285_16447 = state_16192__$1;
(statearr_16285_16447[(2)] = inst_16110);

(statearr_16285_16447[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (42))){
var state_16192__$1 = state_16192;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16192__$1,(45),dchan);
} else {
if((state_val_16193 === (37))){
var inst_16053 = (state_16192[(9)]);
var inst_16157 = (state_16192[(23)]);
var inst_16148 = (state_16192[(25)]);
var inst_16157__$1 = cljs.core.first.call(null,inst_16148);
var inst_16158 = cljs.core.async.put_BANG_.call(null,inst_16157__$1,inst_16053,done);
var state_16192__$1 = (function (){var statearr_16286 = state_16192;
(statearr_16286[(23)] = inst_16157__$1);

return statearr_16286;
})();
if(cljs.core.truth_(inst_16158)){
var statearr_16287_16458 = state_16192__$1;
(statearr_16287_16458[(1)] = (39));

} else {
var statearr_16288_16459 = state_16192__$1;
(statearr_16288_16459[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16193 === (8))){
var inst_16065 = (state_16192[(16)]);
var inst_16064 = (state_16192[(17)]);
var inst_16067 = (inst_16065 < inst_16064);
var inst_16068 = inst_16067;
var state_16192__$1 = state_16192;
if(cljs.core.truth_(inst_16068)){
var statearr_16289_16461 = state_16192__$1;
(statearr_16289_16461[(1)] = (10));

} else {
var statearr_16290_16462 = state_16192__$1;
(statearr_16290_16462[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___16305,cs,m,dchan,dctr,done))
;
return ((function (switch__13813__auto__,c__13836__auto___16305,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__13814__auto__ = null;
var cljs$core$async$mult_$_state_machine__13814__auto____0 = (function (){
var statearr_16294 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16294[(0)] = cljs$core$async$mult_$_state_machine__13814__auto__);

(statearr_16294[(1)] = (1));

return statearr_16294;
});
var cljs$core$async$mult_$_state_machine__13814__auto____1 = (function (state_16192){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_16192);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e16296){if((e16296 instanceof Object)){
var ex__13817__auto__ = e16296;
var statearr_16297_16470 = state_16192;
(statearr_16297_16470[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16192);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16296;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16472 = state_16192;
state_16192 = G__16472;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__13814__auto__ = function(state_16192){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__13814__auto____1.call(this,state_16192);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__13814__auto____0;
cljs$core$async$mult_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__13814__auto____1;
return cljs$core$async$mult_$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___16305,cs,m,dchan,dctr,done))
})();
var state__13838__auto__ = (function (){var statearr_16299 = f__13837__auto__.call(null);
(statearr_16299[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___16305);

return statearr_16299;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___16305,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args16473 = [];
var len__7651__auto___16481 = arguments.length;
var i__7652__auto___16482 = (0);
while(true){
if((i__7652__auto___16482 < len__7651__auto___16481)){
args16473.push((arguments[i__7652__auto___16482]));

var G__16484 = (i__7652__auto___16482 + (1));
i__7652__auto___16482 = G__16484;
continue;
} else {
}
break;
}

var G__16477 = args16473.length;
switch (G__16477) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16473.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m);
} else {
var m__7207__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,state_map);
} else {
var m__7207__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,mode);
} else {
var m__7207__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__7658__auto__ = [];
var len__7651__auto___16523 = arguments.length;
var i__7652__auto___16524 = (0);
while(true){
if((i__7652__auto___16524 < len__7651__auto___16523)){
args__7658__auto__.push((arguments[i__7652__auto___16524]));

var G__16527 = (i__7652__auto___16524 + (1));
i__7652__auto___16524 = G__16527;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((3) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__7659__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__16512){
var map__16513 = p__16512;
var map__16513__$1 = ((((!((map__16513 == null)))?((((map__16513.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__16513.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__16513):map__16513);
var opts = map__16513__$1;
var statearr_16517_16529 = state;
(statearr_16517_16529[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4657__auto__ = cljs.core.async.do_alts.call(null,((function (map__16513,map__16513__$1,opts){
return (function (val){
var statearr_16519_16530 = state;
(statearr_16519_16530[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__16513,map__16513__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4657__auto__)){
var cb = temp__4657__auto__;
var statearr_16520_16535 = state;
(statearr_16520_16535[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq16508){
var G__16509 = cljs.core.first.call(null,seq16508);
var seq16508__$1 = cljs.core.next.call(null,seq16508);
var G__16510 = cljs.core.first.call(null,seq16508__$1);
var seq16508__$2 = cljs.core.next.call(null,seq16508__$1);
var G__16511 = cljs.core.first.call(null,seq16508__$2);
var seq16508__$3 = cljs.core.next.call(null,seq16508__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__16509,G__16510,G__16511,seq16508__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,(((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async16713 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16713 = (function (out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,meta16714){
this.out = out;
this.cs = cs;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.solo_mode = solo_mode;
this.change = change;
this.changed = changed;
this.pick = pick;
this.calc_state = calc_state;
this.meta16714 = meta16714;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_16715,meta16714__$1){
var self__ = this;
var _16715__$1 = this;
return (new cljs.core.async.t_cljs$core$async16713(self__.out,self__.cs,self__.solo_modes,self__.attrs,self__.solo_mode,self__.change,self__.changed,self__.pick,self__.calc_state,meta16714__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_16715){
var self__ = this;
var _16715__$1 = this;
return self__.meta16714;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str("(solo-modes mode)")].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"meta16714","meta16714",1216066501,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16713.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16713.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16713";

cljs.core.async.t_cljs$core$async16713.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16713");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async16713 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async16713(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta16714){
return (new cljs.core.async.t_cljs$core$async16713(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta16714));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async16713(out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__13836__auto___16925 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___16925,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___16925,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_16821){
var state_val_16822 = (state_16821[(1)]);
if((state_val_16822 === (7))){
var inst_16736 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
var statearr_16823_16926 = state_16821__$1;
(statearr_16823_16926[(2)] = inst_16736);

(statearr_16823_16926[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (20))){
var inst_16748 = (state_16821[(7)]);
var state_16821__$1 = state_16821;
var statearr_16824_16927 = state_16821__$1;
(statearr_16824_16927[(2)] = inst_16748);

(statearr_16824_16927[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (27))){
var state_16821__$1 = state_16821;
var statearr_16825_16928 = state_16821__$1;
(statearr_16825_16928[(2)] = null);

(statearr_16825_16928[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (1))){
var inst_16723 = (state_16821[(8)]);
var inst_16723__$1 = calc_state.call(null);
var inst_16725 = (inst_16723__$1 == null);
var inst_16726 = cljs.core.not.call(null,inst_16725);
var state_16821__$1 = (function (){var statearr_16826 = state_16821;
(statearr_16826[(8)] = inst_16723__$1);

return statearr_16826;
})();
if(inst_16726){
var statearr_16827_16929 = state_16821__$1;
(statearr_16827_16929[(1)] = (2));

} else {
var statearr_16828_16930 = state_16821__$1;
(statearr_16828_16930[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (24))){
var inst_16772 = (state_16821[(9)]);
var inst_16795 = (state_16821[(10)]);
var inst_16781 = (state_16821[(11)]);
var inst_16795__$1 = inst_16772.call(null,inst_16781);
var state_16821__$1 = (function (){var statearr_16829 = state_16821;
(statearr_16829[(10)] = inst_16795__$1);

return statearr_16829;
})();
if(cljs.core.truth_(inst_16795__$1)){
var statearr_16830_16931 = state_16821__$1;
(statearr_16830_16931[(1)] = (29));

} else {
var statearr_16831_16932 = state_16821__$1;
(statearr_16831_16932[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (4))){
var inst_16739 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16739)){
var statearr_16835_16933 = state_16821__$1;
(statearr_16835_16933[(1)] = (8));

} else {
var statearr_16836_16934 = state_16821__$1;
(statearr_16836_16934[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (15))){
var inst_16766 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16766)){
var statearr_16840_16935 = state_16821__$1;
(statearr_16840_16935[(1)] = (19));

} else {
var statearr_16841_16936 = state_16821__$1;
(statearr_16841_16936[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (21))){
var inst_16771 = (state_16821[(12)]);
var inst_16771__$1 = (state_16821[(2)]);
var inst_16772 = cljs.core.get.call(null,inst_16771__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_16773 = cljs.core.get.call(null,inst_16771__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_16774 = cljs.core.get.call(null,inst_16771__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_16821__$1 = (function (){var statearr_16842 = state_16821;
(statearr_16842[(13)] = inst_16773);

(statearr_16842[(9)] = inst_16772);

(statearr_16842[(12)] = inst_16771__$1);

return statearr_16842;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_16821__$1,(22),inst_16774);
} else {
if((state_val_16822 === (31))){
var inst_16803 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16803)){
var statearr_16843_16937 = state_16821__$1;
(statearr_16843_16937[(1)] = (32));

} else {
var statearr_16844_16938 = state_16821__$1;
(statearr_16844_16938[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (32))){
var inst_16780 = (state_16821[(14)]);
var state_16821__$1 = state_16821;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16821__$1,(35),out,inst_16780);
} else {
if((state_val_16822 === (33))){
var inst_16771 = (state_16821[(12)]);
var inst_16748 = inst_16771;
var state_16821__$1 = (function (){var statearr_16845 = state_16821;
(statearr_16845[(7)] = inst_16748);

return statearr_16845;
})();
var statearr_16846_16939 = state_16821__$1;
(statearr_16846_16939[(2)] = null);

(statearr_16846_16939[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (13))){
var inst_16748 = (state_16821[(7)]);
var inst_16755 = inst_16748.cljs$lang$protocol_mask$partition0$;
var inst_16756 = (inst_16755 & (64));
var inst_16757 = inst_16748.cljs$core$ISeq$;
var inst_16758 = (cljs.core.PROTOCOL_SENTINEL === inst_16757);
var inst_16759 = (inst_16756) || (inst_16758);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16759)){
var statearr_16847_16940 = state_16821__$1;
(statearr_16847_16940[(1)] = (16));

} else {
var statearr_16848_16941 = state_16821__$1;
(statearr_16848_16941[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (22))){
var inst_16781 = (state_16821[(11)]);
var inst_16780 = (state_16821[(14)]);
var inst_16779 = (state_16821[(2)]);
var inst_16780__$1 = cljs.core.nth.call(null,inst_16779,(0),null);
var inst_16781__$1 = cljs.core.nth.call(null,inst_16779,(1),null);
var inst_16782 = (inst_16780__$1 == null);
var inst_16783 = cljs.core._EQ_.call(null,inst_16781__$1,change);
var inst_16784 = (inst_16782) || (inst_16783);
var state_16821__$1 = (function (){var statearr_16849 = state_16821;
(statearr_16849[(11)] = inst_16781__$1);

(statearr_16849[(14)] = inst_16780__$1);

return statearr_16849;
})();
if(cljs.core.truth_(inst_16784)){
var statearr_16850_16946 = state_16821__$1;
(statearr_16850_16946[(1)] = (23));

} else {
var statearr_16851_16947 = state_16821__$1;
(statearr_16851_16947[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (36))){
var inst_16771 = (state_16821[(12)]);
var inst_16748 = inst_16771;
var state_16821__$1 = (function (){var statearr_16852 = state_16821;
(statearr_16852[(7)] = inst_16748);

return statearr_16852;
})();
var statearr_16853_16949 = state_16821__$1;
(statearr_16853_16949[(2)] = null);

(statearr_16853_16949[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (29))){
var inst_16795 = (state_16821[(10)]);
var state_16821__$1 = state_16821;
var statearr_16854_16959 = state_16821__$1;
(statearr_16854_16959[(2)] = inst_16795);

(statearr_16854_16959[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (6))){
var state_16821__$1 = state_16821;
var statearr_16855_16963 = state_16821__$1;
(statearr_16855_16963[(2)] = false);

(statearr_16855_16963[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (28))){
var inst_16791 = (state_16821[(2)]);
var inst_16792 = calc_state.call(null);
var inst_16748 = inst_16792;
var state_16821__$1 = (function (){var statearr_16856 = state_16821;
(statearr_16856[(15)] = inst_16791);

(statearr_16856[(7)] = inst_16748);

return statearr_16856;
})();
var statearr_16857_16974 = state_16821__$1;
(statearr_16857_16974[(2)] = null);

(statearr_16857_16974[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (25))){
var inst_16817 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
var statearr_16858_16975 = state_16821__$1;
(statearr_16858_16975[(2)] = inst_16817);

(statearr_16858_16975[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (34))){
var inst_16815 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
var statearr_16859_16976 = state_16821__$1;
(statearr_16859_16976[(2)] = inst_16815);

(statearr_16859_16976[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (17))){
var state_16821__$1 = state_16821;
var statearr_16860_16977 = state_16821__$1;
(statearr_16860_16977[(2)] = false);

(statearr_16860_16977[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (3))){
var state_16821__$1 = state_16821;
var statearr_16861_16978 = state_16821__$1;
(statearr_16861_16978[(2)] = false);

(statearr_16861_16978[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (12))){
var inst_16819 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16821__$1,inst_16819);
} else {
if((state_val_16822 === (2))){
var inst_16723 = (state_16821[(8)]);
var inst_16728 = inst_16723.cljs$lang$protocol_mask$partition0$;
var inst_16729 = (inst_16728 & (64));
var inst_16730 = inst_16723.cljs$core$ISeq$;
var inst_16731 = (cljs.core.PROTOCOL_SENTINEL === inst_16730);
var inst_16732 = (inst_16729) || (inst_16731);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16732)){
var statearr_16862_16985 = state_16821__$1;
(statearr_16862_16985[(1)] = (5));

} else {
var statearr_16863_16986 = state_16821__$1;
(statearr_16863_16986[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (23))){
var inst_16780 = (state_16821[(14)]);
var inst_16786 = (inst_16780 == null);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16786)){
var statearr_16864_16987 = state_16821__$1;
(statearr_16864_16987[(1)] = (26));

} else {
var statearr_16865_16988 = state_16821__$1;
(statearr_16865_16988[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (35))){
var inst_16806 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
if(cljs.core.truth_(inst_16806)){
var statearr_16866_16989 = state_16821__$1;
(statearr_16866_16989[(1)] = (36));

} else {
var statearr_16867_16990 = state_16821__$1;
(statearr_16867_16990[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (19))){
var inst_16748 = (state_16821[(7)]);
var inst_16768 = cljs.core.apply.call(null,cljs.core.hash_map,inst_16748);
var state_16821__$1 = state_16821;
var statearr_16868_16993 = state_16821__$1;
(statearr_16868_16993[(2)] = inst_16768);

(statearr_16868_16993[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (11))){
var inst_16748 = (state_16821[(7)]);
var inst_16752 = (inst_16748 == null);
var inst_16753 = cljs.core.not.call(null,inst_16752);
var state_16821__$1 = state_16821;
if(inst_16753){
var statearr_16869_16999 = state_16821__$1;
(statearr_16869_16999[(1)] = (13));

} else {
var statearr_16870_17000 = state_16821__$1;
(statearr_16870_17000[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (9))){
var inst_16723 = (state_16821[(8)]);
var state_16821__$1 = state_16821;
var statearr_16871_17004 = state_16821__$1;
(statearr_16871_17004[(2)] = inst_16723);

(statearr_16871_17004[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (5))){
var state_16821__$1 = state_16821;
var statearr_16872_17005 = state_16821__$1;
(statearr_16872_17005[(2)] = true);

(statearr_16872_17005[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (14))){
var state_16821__$1 = state_16821;
var statearr_16873_17006 = state_16821__$1;
(statearr_16873_17006[(2)] = false);

(statearr_16873_17006[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (26))){
var inst_16781 = (state_16821[(11)]);
var inst_16788 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_16781);
var state_16821__$1 = state_16821;
var statearr_16874_17007 = state_16821__$1;
(statearr_16874_17007[(2)] = inst_16788);

(statearr_16874_17007[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (16))){
var state_16821__$1 = state_16821;
var statearr_16875_17009 = state_16821__$1;
(statearr_16875_17009[(2)] = true);

(statearr_16875_17009[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (38))){
var inst_16811 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
var statearr_16876_17011 = state_16821__$1;
(statearr_16876_17011[(2)] = inst_16811);

(statearr_16876_17011[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (30))){
var inst_16773 = (state_16821[(13)]);
var inst_16772 = (state_16821[(9)]);
var inst_16781 = (state_16821[(11)]);
var inst_16798 = cljs.core.empty_QMARK_.call(null,inst_16772);
var inst_16799 = inst_16773.call(null,inst_16781);
var inst_16800 = cljs.core.not.call(null,inst_16799);
var inst_16801 = (inst_16798) && (inst_16800);
var state_16821__$1 = state_16821;
var statearr_16879_17015 = state_16821__$1;
(statearr_16879_17015[(2)] = inst_16801);

(statearr_16879_17015[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (10))){
var inst_16723 = (state_16821[(8)]);
var inst_16744 = (state_16821[(2)]);
var inst_16745 = cljs.core.get.call(null,inst_16744,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_16746 = cljs.core.get.call(null,inst_16744,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_16747 = cljs.core.get.call(null,inst_16744,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_16748 = inst_16723;
var state_16821__$1 = (function (){var statearr_16880 = state_16821;
(statearr_16880[(16)] = inst_16746);

(statearr_16880[(17)] = inst_16745);

(statearr_16880[(18)] = inst_16747);

(statearr_16880[(7)] = inst_16748);

return statearr_16880;
})();
var statearr_16882_17018 = state_16821__$1;
(statearr_16882_17018[(2)] = null);

(statearr_16882_17018[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (18))){
var inst_16763 = (state_16821[(2)]);
var state_16821__$1 = state_16821;
var statearr_16886_17019 = state_16821__$1;
(statearr_16886_17019[(2)] = inst_16763);

(statearr_16886_17019[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (37))){
var state_16821__$1 = state_16821;
var statearr_16887_17020 = state_16821__$1;
(statearr_16887_17020[(2)] = null);

(statearr_16887_17020[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16822 === (8))){
var inst_16723 = (state_16821[(8)]);
var inst_16741 = cljs.core.apply.call(null,cljs.core.hash_map,inst_16723);
var state_16821__$1 = state_16821;
var statearr_16888_17023 = state_16821__$1;
(statearr_16888_17023[(2)] = inst_16741);

(statearr_16888_17023[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___16925,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__13813__auto__,c__13836__auto___16925,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__13814__auto__ = null;
var cljs$core$async$mix_$_state_machine__13814__auto____0 = (function (){
var statearr_16893 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16893[(0)] = cljs$core$async$mix_$_state_machine__13814__auto__);

(statearr_16893[(1)] = (1));

return statearr_16893;
});
var cljs$core$async$mix_$_state_machine__13814__auto____1 = (function (state_16821){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_16821);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e16894){if((e16894 instanceof Object)){
var ex__13817__auto__ = e16894;
var statearr_16895_17027 = state_16821;
(statearr_16895_17027[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16821);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16894;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17029 = state_16821;
state_16821 = G__17029;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__13814__auto__ = function(state_16821){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__13814__auto____1.call(this,state_16821);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__13814__auto____0;
cljs$core$async$mix_$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__13814__auto____1;
return cljs$core$async$mix_$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___16925,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__13838__auto__ = (function (){var statearr_16896 = f__13837__auto__.call(null);
(statearr_16896[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___16925);

return statearr_16896;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___16925,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__7207__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args17042 = [];
var len__7651__auto___17045 = arguments.length;
var i__7652__auto___17046 = (0);
while(true){
if((i__7652__auto___17046 < len__7651__auto___17045)){
args17042.push((arguments[i__7652__auto___17046]));

var G__17047 = (i__7652__auto___17046 + (1));
i__7652__auto___17046 = G__17047;
continue;
} else {
}
break;
}

var G__17044 = args17042.length;
switch (G__17044) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17042.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args17061 = [];
var len__7651__auto___17207 = arguments.length;
var i__7652__auto___17208 = (0);
while(true){
if((i__7652__auto___17208 < len__7651__auto___17207)){
args17061.push((arguments[i__7652__auto___17208]));

var G__17209 = (i__7652__auto___17208 + (1));
i__7652__auto___17208 = G__17209;
continue;
} else {
}
break;
}

var G__17063 = args17061.length;
switch (G__17063) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17061.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__6543__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__6543__auto__,mults){
return (function (p1__17060_SHARP_){
if(cljs.core.truth_(p1__17060_SHARP_.call(null,topic))){
return p1__17060_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__17060_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__6543__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async17064 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17064 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta17065){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta17065 = meta17065;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_17066,meta17065__$1){
var self__ = this;
var _17066__$1 = this;
return (new cljs.core.async.t_cljs$core$async17064(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta17065__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_17066){
var self__ = this;
var _17066__$1 = this;
return self__.meta17065;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4657__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4657__auto__)){
var m = temp__4657__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta17065","meta17065",1354883029,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17064.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17064.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17064";

cljs.core.async.t_cljs$core$async17064.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17064");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async17064 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async17064(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta17065){
return (new cljs.core.async.t_cljs$core$async17064(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta17065));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async17064(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__13836__auto___17240 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___17240,mults,ensure_mult,p){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___17240,mults,ensure_mult,p){
return (function (state_17148){
var state_val_17149 = (state_17148[(1)]);
if((state_val_17149 === (7))){
var inst_17144 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
var statearr_17154_17245 = state_17148__$1;
(statearr_17154_17245[(2)] = inst_17144);

(statearr_17154_17245[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (20))){
var state_17148__$1 = state_17148;
var statearr_17155_17249 = state_17148__$1;
(statearr_17155_17249[(2)] = null);

(statearr_17155_17249[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (1))){
var state_17148__$1 = state_17148;
var statearr_17156_17254 = state_17148__$1;
(statearr_17156_17254[(2)] = null);

(statearr_17156_17254[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (24))){
var inst_17123 = (state_17148[(7)]);
var inst_17136 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_17123);
var state_17148__$1 = state_17148;
var statearr_17160_17255 = state_17148__$1;
(statearr_17160_17255[(2)] = inst_17136);

(statearr_17160_17255[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (4))){
var inst_17069 = (state_17148[(8)]);
var inst_17069__$1 = (state_17148[(2)]);
var inst_17070 = (inst_17069__$1 == null);
var state_17148__$1 = (function (){var statearr_17161 = state_17148;
(statearr_17161[(8)] = inst_17069__$1);

return statearr_17161;
})();
if(cljs.core.truth_(inst_17070)){
var statearr_17162_17256 = state_17148__$1;
(statearr_17162_17256[(1)] = (5));

} else {
var statearr_17163_17257 = state_17148__$1;
(statearr_17163_17257[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (15))){
var inst_17117 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
var statearr_17164_17258 = state_17148__$1;
(statearr_17164_17258[(2)] = inst_17117);

(statearr_17164_17258[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (21))){
var inst_17141 = (state_17148[(2)]);
var state_17148__$1 = (function (){var statearr_17167 = state_17148;
(statearr_17167[(9)] = inst_17141);

return statearr_17167;
})();
var statearr_17168_17262 = state_17148__$1;
(statearr_17168_17262[(2)] = null);

(statearr_17168_17262[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (13))){
var inst_17097 = (state_17148[(10)]);
var inst_17099 = cljs.core.chunked_seq_QMARK_.call(null,inst_17097);
var state_17148__$1 = state_17148;
if(inst_17099){
var statearr_17169_17263 = state_17148__$1;
(statearr_17169_17263[(1)] = (16));

} else {
var statearr_17172_17267 = state_17148__$1;
(statearr_17172_17267[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (22))){
var inst_17133 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
if(cljs.core.truth_(inst_17133)){
var statearr_17173_17268 = state_17148__$1;
(statearr_17173_17268[(1)] = (23));

} else {
var statearr_17174_17269 = state_17148__$1;
(statearr_17174_17269[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (6))){
var inst_17126 = (state_17148[(11)]);
var inst_17069 = (state_17148[(8)]);
var inst_17123 = (state_17148[(7)]);
var inst_17123__$1 = topic_fn.call(null,inst_17069);
var inst_17124 = cljs.core.deref.call(null,mults);
var inst_17126__$1 = cljs.core.get.call(null,inst_17124,inst_17123__$1);
var state_17148__$1 = (function (){var statearr_17175 = state_17148;
(statearr_17175[(11)] = inst_17126__$1);

(statearr_17175[(7)] = inst_17123__$1);

return statearr_17175;
})();
if(cljs.core.truth_(inst_17126__$1)){
var statearr_17176_17274 = state_17148__$1;
(statearr_17176_17274[(1)] = (19));

} else {
var statearr_17177_17275 = state_17148__$1;
(statearr_17177_17275[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (25))){
var inst_17138 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
var statearr_17178_17280 = state_17148__$1;
(statearr_17178_17280[(2)] = inst_17138);

(statearr_17178_17280[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (17))){
var inst_17097 = (state_17148[(10)]);
var inst_17106 = cljs.core.first.call(null,inst_17097);
var inst_17108 = cljs.core.async.muxch_STAR_.call(null,inst_17106);
var inst_17109 = cljs.core.async.close_BANG_.call(null,inst_17108);
var inst_17111 = cljs.core.next.call(null,inst_17097);
var inst_17079 = inst_17111;
var inst_17080 = null;
var inst_17081 = (0);
var inst_17082 = (0);
var state_17148__$1 = (function (){var statearr_17179 = state_17148;
(statearr_17179[(12)] = inst_17080);

(statearr_17179[(13)] = inst_17082);

(statearr_17179[(14)] = inst_17109);

(statearr_17179[(15)] = inst_17081);

(statearr_17179[(16)] = inst_17079);

return statearr_17179;
})();
var statearr_17180_17282 = state_17148__$1;
(statearr_17180_17282[(2)] = null);

(statearr_17180_17282[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (3))){
var inst_17146 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17148__$1,inst_17146);
} else {
if((state_val_17149 === (12))){
var inst_17119 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
var statearr_17181_17288 = state_17148__$1;
(statearr_17181_17288[(2)] = inst_17119);

(statearr_17181_17288[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (2))){
var state_17148__$1 = state_17148;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17148__$1,(4),ch);
} else {
if((state_val_17149 === (23))){
var state_17148__$1 = state_17148;
var statearr_17182_17294 = state_17148__$1;
(statearr_17182_17294[(2)] = null);

(statearr_17182_17294[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (19))){
var inst_17126 = (state_17148[(11)]);
var inst_17069 = (state_17148[(8)]);
var inst_17131 = cljs.core.async.muxch_STAR_.call(null,inst_17126);
var state_17148__$1 = state_17148;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17148__$1,(22),inst_17131,inst_17069);
} else {
if((state_val_17149 === (11))){
var inst_17079 = (state_17148[(16)]);
var inst_17097 = (state_17148[(10)]);
var inst_17097__$1 = cljs.core.seq.call(null,inst_17079);
var state_17148__$1 = (function (){var statearr_17183 = state_17148;
(statearr_17183[(10)] = inst_17097__$1);

return statearr_17183;
})();
if(inst_17097__$1){
var statearr_17184_17298 = state_17148__$1;
(statearr_17184_17298[(1)] = (13));

} else {
var statearr_17185_17299 = state_17148__$1;
(statearr_17185_17299[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (9))){
var inst_17121 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
var statearr_17186_17300 = state_17148__$1;
(statearr_17186_17300[(2)] = inst_17121);

(statearr_17186_17300[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (5))){
var inst_17076 = cljs.core.deref.call(null,mults);
var inst_17077 = cljs.core.vals.call(null,inst_17076);
var inst_17078 = cljs.core.seq.call(null,inst_17077);
var inst_17079 = inst_17078;
var inst_17080 = null;
var inst_17081 = (0);
var inst_17082 = (0);
var state_17148__$1 = (function (){var statearr_17187 = state_17148;
(statearr_17187[(12)] = inst_17080);

(statearr_17187[(13)] = inst_17082);

(statearr_17187[(15)] = inst_17081);

(statearr_17187[(16)] = inst_17079);

return statearr_17187;
})();
var statearr_17188_17301 = state_17148__$1;
(statearr_17188_17301[(2)] = null);

(statearr_17188_17301[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (14))){
var state_17148__$1 = state_17148;
var statearr_17192_17305 = state_17148__$1;
(statearr_17192_17305[(2)] = null);

(statearr_17192_17305[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (16))){
var inst_17097 = (state_17148[(10)]);
var inst_17101 = cljs.core.chunk_first.call(null,inst_17097);
var inst_17102 = cljs.core.chunk_rest.call(null,inst_17097);
var inst_17103 = cljs.core.count.call(null,inst_17101);
var inst_17079 = inst_17102;
var inst_17080 = inst_17101;
var inst_17081 = inst_17103;
var inst_17082 = (0);
var state_17148__$1 = (function (){var statearr_17193 = state_17148;
(statearr_17193[(12)] = inst_17080);

(statearr_17193[(13)] = inst_17082);

(statearr_17193[(15)] = inst_17081);

(statearr_17193[(16)] = inst_17079);

return statearr_17193;
})();
var statearr_17194_17315 = state_17148__$1;
(statearr_17194_17315[(2)] = null);

(statearr_17194_17315[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (10))){
var inst_17080 = (state_17148[(12)]);
var inst_17082 = (state_17148[(13)]);
var inst_17081 = (state_17148[(15)]);
var inst_17079 = (state_17148[(16)]);
var inst_17091 = cljs.core._nth.call(null,inst_17080,inst_17082);
var inst_17092 = cljs.core.async.muxch_STAR_.call(null,inst_17091);
var inst_17093 = cljs.core.async.close_BANG_.call(null,inst_17092);
var inst_17094 = (inst_17082 + (1));
var tmp17189 = inst_17080;
var tmp17190 = inst_17081;
var tmp17191 = inst_17079;
var inst_17079__$1 = tmp17191;
var inst_17080__$1 = tmp17189;
var inst_17081__$1 = tmp17190;
var inst_17082__$1 = inst_17094;
var state_17148__$1 = (function (){var statearr_17195 = state_17148;
(statearr_17195[(12)] = inst_17080__$1);

(statearr_17195[(13)] = inst_17082__$1);

(statearr_17195[(15)] = inst_17081__$1);

(statearr_17195[(17)] = inst_17093);

(statearr_17195[(16)] = inst_17079__$1);

return statearr_17195;
})();
var statearr_17196_17324 = state_17148__$1;
(statearr_17196_17324[(2)] = null);

(statearr_17196_17324[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (18))){
var inst_17114 = (state_17148[(2)]);
var state_17148__$1 = state_17148;
var statearr_17197_17325 = state_17148__$1;
(statearr_17197_17325[(2)] = inst_17114);

(statearr_17197_17325[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17149 === (8))){
var inst_17082 = (state_17148[(13)]);
var inst_17081 = (state_17148[(15)]);
var inst_17088 = (inst_17082 < inst_17081);
var inst_17089 = inst_17088;
var state_17148__$1 = state_17148;
if(cljs.core.truth_(inst_17089)){
var statearr_17198_17338 = state_17148__$1;
(statearr_17198_17338[(1)] = (10));

} else {
var statearr_17199_17339 = state_17148__$1;
(statearr_17199_17339[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___17240,mults,ensure_mult,p))
;
return ((function (switch__13813__auto__,c__13836__auto___17240,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_17203 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17203[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_17203[(1)] = (1));

return statearr_17203;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_17148){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_17148);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e17204){if((e17204 instanceof Object)){
var ex__13817__auto__ = e17204;
var statearr_17205_17340 = state_17148;
(statearr_17205_17340[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17148);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17204;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17341 = state_17148;
state_17148 = G__17341;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_17148){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_17148);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___17240,mults,ensure_mult,p))
})();
var state__13838__auto__ = (function (){var statearr_17206 = f__13837__auto__.call(null);
(statearr_17206[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___17240);

return statearr_17206;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___17240,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args17342 = [];
var len__7651__auto___17345 = arguments.length;
var i__7652__auto___17346 = (0);
while(true){
if((i__7652__auto___17346 < len__7651__auto___17345)){
args17342.push((arguments[i__7652__auto___17346]));

var G__17347 = (i__7652__auto___17346 + (1));
i__7652__auto___17346 = G__17347;
continue;
} else {
}
break;
}

var G__17344 = args17342.length;
switch (G__17344) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17342.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args17355 = [];
var len__7651__auto___17358 = arguments.length;
var i__7652__auto___17359 = (0);
while(true){
if((i__7652__auto___17359 < len__7651__auto___17358)){
args17355.push((arguments[i__7652__auto___17359]));

var G__17360 = (i__7652__auto___17359 + (1));
i__7652__auto___17359 = G__17360;
continue;
} else {
}
break;
}

var G__17357 = args17355.length;
switch (G__17357) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17355.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args17363 = [];
var len__7651__auto___17445 = arguments.length;
var i__7652__auto___17446 = (0);
while(true){
if((i__7652__auto___17446 < len__7651__auto___17445)){
args17363.push((arguments[i__7652__auto___17446]));

var G__17447 = (i__7652__auto___17446 + (1));
i__7652__auto___17446 = G__17447;
continue;
} else {
}
break;
}

var G__17367 = args17363.length;
switch (G__17367) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17363.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__13836__auto___17449 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___17449,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___17449,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_17408){
var state_val_17409 = (state_17408[(1)]);
if((state_val_17409 === (7))){
var state_17408__$1 = state_17408;
var statearr_17413_17458 = state_17408__$1;
(statearr_17413_17458[(2)] = null);

(statearr_17413_17458[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (1))){
var state_17408__$1 = state_17408;
var statearr_17414_17460 = state_17408__$1;
(statearr_17414_17460[(2)] = null);

(statearr_17414_17460[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (4))){
var inst_17371 = (state_17408[(7)]);
var inst_17373 = (inst_17371 < cnt);
var state_17408__$1 = state_17408;
if(cljs.core.truth_(inst_17373)){
var statearr_17415_17462 = state_17408__$1;
(statearr_17415_17462[(1)] = (6));

} else {
var statearr_17416_17463 = state_17408__$1;
(statearr_17416_17463[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (15))){
var inst_17404 = (state_17408[(2)]);
var state_17408__$1 = state_17408;
var statearr_17417_17464 = state_17408__$1;
(statearr_17417_17464[(2)] = inst_17404);

(statearr_17417_17464[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (13))){
var inst_17397 = cljs.core.async.close_BANG_.call(null,out);
var state_17408__$1 = state_17408;
var statearr_17418_17465 = state_17408__$1;
(statearr_17418_17465[(2)] = inst_17397);

(statearr_17418_17465[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (6))){
var state_17408__$1 = state_17408;
var statearr_17419_17466 = state_17408__$1;
(statearr_17419_17466[(2)] = null);

(statearr_17419_17466[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (3))){
var inst_17406 = (state_17408[(2)]);
var state_17408__$1 = state_17408;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17408__$1,inst_17406);
} else {
if((state_val_17409 === (12))){
var inst_17394 = (state_17408[(8)]);
var inst_17394__$1 = (state_17408[(2)]);
var inst_17395 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_17394__$1);
var state_17408__$1 = (function (){var statearr_17424 = state_17408;
(statearr_17424[(8)] = inst_17394__$1);

return statearr_17424;
})();
if(cljs.core.truth_(inst_17395)){
var statearr_17425_17467 = state_17408__$1;
(statearr_17425_17467[(1)] = (13));

} else {
var statearr_17426_17468 = state_17408__$1;
(statearr_17426_17468[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (2))){
var inst_17370 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_17371 = (0);
var state_17408__$1 = (function (){var statearr_17427 = state_17408;
(statearr_17427[(7)] = inst_17371);

(statearr_17427[(9)] = inst_17370);

return statearr_17427;
})();
var statearr_17428_17481 = state_17408__$1;
(statearr_17428_17481[(2)] = null);

(statearr_17428_17481[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (11))){
var inst_17371 = (state_17408[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_17408,(10),Object,null,(9));
var inst_17381 = chs__$1.call(null,inst_17371);
var inst_17382 = done.call(null,inst_17371);
var inst_17383 = cljs.core.async.take_BANG_.call(null,inst_17381,inst_17382);
var state_17408__$1 = state_17408;
var statearr_17429_17482 = state_17408__$1;
(statearr_17429_17482[(2)] = inst_17383);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17408__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (9))){
var inst_17371 = (state_17408[(7)]);
var inst_17385 = (state_17408[(2)]);
var inst_17386 = (inst_17371 + (1));
var inst_17371__$1 = inst_17386;
var state_17408__$1 = (function (){var statearr_17430 = state_17408;
(statearr_17430[(7)] = inst_17371__$1);

(statearr_17430[(10)] = inst_17385);

return statearr_17430;
})();
var statearr_17431_17495 = state_17408__$1;
(statearr_17431_17495[(2)] = null);

(statearr_17431_17495[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (5))){
var inst_17392 = (state_17408[(2)]);
var state_17408__$1 = (function (){var statearr_17432 = state_17408;
(statearr_17432[(11)] = inst_17392);

return statearr_17432;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17408__$1,(12),dchan);
} else {
if((state_val_17409 === (14))){
var inst_17394 = (state_17408[(8)]);
var inst_17399 = cljs.core.apply.call(null,f,inst_17394);
var state_17408__$1 = state_17408;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17408__$1,(16),out,inst_17399);
} else {
if((state_val_17409 === (16))){
var inst_17401 = (state_17408[(2)]);
var state_17408__$1 = (function (){var statearr_17433 = state_17408;
(statearr_17433[(12)] = inst_17401);

return statearr_17433;
})();
var statearr_17434_17498 = state_17408__$1;
(statearr_17434_17498[(2)] = null);

(statearr_17434_17498[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (10))){
var inst_17376 = (state_17408[(2)]);
var inst_17377 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_17408__$1 = (function (){var statearr_17435 = state_17408;
(statearr_17435[(13)] = inst_17376);

return statearr_17435;
})();
var statearr_17436_17499 = state_17408__$1;
(statearr_17436_17499[(2)] = inst_17377);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17408__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17409 === (8))){
var inst_17390 = (state_17408[(2)]);
var state_17408__$1 = state_17408;
var statearr_17437_17500 = state_17408__$1;
(statearr_17437_17500[(2)] = inst_17390);

(statearr_17437_17500[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___17449,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__13813__auto__,c__13836__auto___17449,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_17441 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17441[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_17441[(1)] = (1));

return statearr_17441;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_17408){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_17408);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e17442){if((e17442 instanceof Object)){
var ex__13817__auto__ = e17442;
var statearr_17443_17501 = state_17408;
(statearr_17443_17501[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17408);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17442;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17507 = state_17408;
state_17408 = G__17507;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_17408){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_17408);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___17449,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__13838__auto__ = (function (){var statearr_17444 = f__13837__auto__.call(null);
(statearr_17444[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___17449);

return statearr_17444;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___17449,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args17509 = [];
var len__7651__auto___17607 = arguments.length;
var i__7652__auto___17608 = (0);
while(true){
if((i__7652__auto___17608 < len__7651__auto___17607)){
args17509.push((arguments[i__7652__auto___17608]));

var G__17609 = (i__7652__auto___17608 + (1));
i__7652__auto___17608 = G__17609;
continue;
} else {
}
break;
}

var G__17511 = args17509.length;
switch (G__17511) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17509.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13836__auto___17611 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___17611,out){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___17611,out){
return (function (state_17553){
var state_val_17557 = (state_17553[(1)]);
if((state_val_17557 === (7))){
var inst_17523 = (state_17553[(7)]);
var inst_17522 = (state_17553[(8)]);
var inst_17522__$1 = (state_17553[(2)]);
var inst_17523__$1 = cljs.core.nth.call(null,inst_17522__$1,(0),null);
var inst_17524 = cljs.core.nth.call(null,inst_17522__$1,(1),null);
var inst_17525 = (inst_17523__$1 == null);
var state_17553__$1 = (function (){var statearr_17561 = state_17553;
(statearr_17561[(7)] = inst_17523__$1);

(statearr_17561[(9)] = inst_17524);

(statearr_17561[(8)] = inst_17522__$1);

return statearr_17561;
})();
if(cljs.core.truth_(inst_17525)){
var statearr_17562_17642 = state_17553__$1;
(statearr_17562_17642[(1)] = (8));

} else {
var statearr_17563_17643 = state_17553__$1;
(statearr_17563_17643[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (1))){
var inst_17512 = cljs.core.vec.call(null,chs);
var inst_17513 = inst_17512;
var state_17553__$1 = (function (){var statearr_17564 = state_17553;
(statearr_17564[(10)] = inst_17513);

return statearr_17564;
})();
var statearr_17565_17647 = state_17553__$1;
(statearr_17565_17647[(2)] = null);

(statearr_17565_17647[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (4))){
var inst_17513 = (state_17553[(10)]);
var state_17553__$1 = state_17553;
return cljs.core.async.ioc_alts_BANG_.call(null,state_17553__$1,(7),inst_17513);
} else {
if((state_val_17557 === (6))){
var inst_17549 = (state_17553[(2)]);
var state_17553__$1 = state_17553;
var statearr_17566_17651 = state_17553__$1;
(statearr_17566_17651[(2)] = inst_17549);

(statearr_17566_17651[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (3))){
var inst_17551 = (state_17553[(2)]);
var state_17553__$1 = state_17553;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17553__$1,inst_17551);
} else {
if((state_val_17557 === (2))){
var inst_17513 = (state_17553[(10)]);
var inst_17515 = cljs.core.count.call(null,inst_17513);
var inst_17516 = (inst_17515 > (0));
var state_17553__$1 = state_17553;
if(cljs.core.truth_(inst_17516)){
var statearr_17568_17652 = state_17553__$1;
(statearr_17568_17652[(1)] = (4));

} else {
var statearr_17569_17653 = state_17553__$1;
(statearr_17569_17653[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (11))){
var inst_17513 = (state_17553[(10)]);
var inst_17539 = (state_17553[(2)]);
var tmp17567 = inst_17513;
var inst_17513__$1 = tmp17567;
var state_17553__$1 = (function (){var statearr_17570 = state_17553;
(statearr_17570[(11)] = inst_17539);

(statearr_17570[(10)] = inst_17513__$1);

return statearr_17570;
})();
var statearr_17571_17654 = state_17553__$1;
(statearr_17571_17654[(2)] = null);

(statearr_17571_17654[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (9))){
var inst_17523 = (state_17553[(7)]);
var state_17553__$1 = state_17553;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17553__$1,(11),out,inst_17523);
} else {
if((state_val_17557 === (5))){
var inst_17547 = cljs.core.async.close_BANG_.call(null,out);
var state_17553__$1 = state_17553;
var statearr_17572_17660 = state_17553__$1;
(statearr_17572_17660[(2)] = inst_17547);

(statearr_17572_17660[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (10))){
var inst_17545 = (state_17553[(2)]);
var state_17553__$1 = state_17553;
var statearr_17573_17661 = state_17553__$1;
(statearr_17573_17661[(2)] = inst_17545);

(statearr_17573_17661[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17557 === (8))){
var inst_17523 = (state_17553[(7)]);
var inst_17524 = (state_17553[(9)]);
var inst_17522 = (state_17553[(8)]);
var inst_17513 = (state_17553[(10)]);
var inst_17530 = (function (){var cs = inst_17513;
var vec__17518 = inst_17522;
var v = inst_17523;
var c = inst_17524;
return ((function (cs,vec__17518,v,c,inst_17523,inst_17524,inst_17522,inst_17513,state_val_17557,c__13836__auto___17611,out){
return (function (p1__17508_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__17508_SHARP_);
});
;})(cs,vec__17518,v,c,inst_17523,inst_17524,inst_17522,inst_17513,state_val_17557,c__13836__auto___17611,out))
})();
var inst_17531 = cljs.core.filterv.call(null,inst_17530,inst_17513);
var inst_17513__$1 = inst_17531;
var state_17553__$1 = (function (){var statearr_17584 = state_17553;
(statearr_17584[(10)] = inst_17513__$1);

return statearr_17584;
})();
var statearr_17589_17664 = state_17553__$1;
(statearr_17589_17664[(2)] = null);

(statearr_17589_17664[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___17611,out))
;
return ((function (switch__13813__auto__,c__13836__auto___17611,out){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_17603 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17603[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_17603[(1)] = (1));

return statearr_17603;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_17553){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_17553);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e17604){if((e17604 instanceof Object)){
var ex__13817__auto__ = e17604;
var statearr_17605_17679 = state_17553;
(statearr_17605_17679[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17553);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17604;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17681 = state_17553;
state_17553 = G__17681;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_17553){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_17553);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___17611,out))
})();
var state__13838__auto__ = (function (){var statearr_17606 = f__13837__auto__.call(null);
(statearr_17606[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___17611);

return statearr_17606;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___17611,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args17691 = [];
var len__7651__auto___17758 = arguments.length;
var i__7652__auto___17759 = (0);
while(true){
if((i__7652__auto___17759 < len__7651__auto___17758)){
args17691.push((arguments[i__7652__auto___17759]));

var G__17760 = (i__7652__auto___17759 + (1));
i__7652__auto___17759 = G__17760;
continue;
} else {
}
break;
}

var G__17693 = args17691.length;
switch (G__17693) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17691.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13836__auto___17762 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___17762,out){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___17762,out){
return (function (state_17717){
var state_val_17718 = (state_17717[(1)]);
if((state_val_17718 === (7))){
var inst_17699 = (state_17717[(7)]);
var inst_17699__$1 = (state_17717[(2)]);
var inst_17700 = (inst_17699__$1 == null);
var inst_17701 = cljs.core.not.call(null,inst_17700);
var state_17717__$1 = (function (){var statearr_17728 = state_17717;
(statearr_17728[(7)] = inst_17699__$1);

return statearr_17728;
})();
if(inst_17701){
var statearr_17729_17766 = state_17717__$1;
(statearr_17729_17766[(1)] = (8));

} else {
var statearr_17730_17770 = state_17717__$1;
(statearr_17730_17770[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (1))){
var inst_17694 = (0);
var state_17717__$1 = (function (){var statearr_17731 = state_17717;
(statearr_17731[(8)] = inst_17694);

return statearr_17731;
})();
var statearr_17732_17774 = state_17717__$1;
(statearr_17732_17774[(2)] = null);

(statearr_17732_17774[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (4))){
var state_17717__$1 = state_17717;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17717__$1,(7),ch);
} else {
if((state_val_17718 === (6))){
var inst_17712 = (state_17717[(2)]);
var state_17717__$1 = state_17717;
var statearr_17733_17775 = state_17717__$1;
(statearr_17733_17775[(2)] = inst_17712);

(statearr_17733_17775[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (3))){
var inst_17714 = (state_17717[(2)]);
var inst_17715 = cljs.core.async.close_BANG_.call(null,out);
var state_17717__$1 = (function (){var statearr_17734 = state_17717;
(statearr_17734[(9)] = inst_17714);

return statearr_17734;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17717__$1,inst_17715);
} else {
if((state_val_17718 === (2))){
var inst_17694 = (state_17717[(8)]);
var inst_17696 = (inst_17694 < n);
var state_17717__$1 = state_17717;
if(cljs.core.truth_(inst_17696)){
var statearr_17744_17797 = state_17717__$1;
(statearr_17744_17797[(1)] = (4));

} else {
var statearr_17745_17803 = state_17717__$1;
(statearr_17745_17803[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (11))){
var inst_17694 = (state_17717[(8)]);
var inst_17704 = (state_17717[(2)]);
var inst_17705 = (inst_17694 + (1));
var inst_17694__$1 = inst_17705;
var state_17717__$1 = (function (){var statearr_17746 = state_17717;
(statearr_17746[(10)] = inst_17704);

(statearr_17746[(8)] = inst_17694__$1);

return statearr_17746;
})();
var statearr_17747_17809 = state_17717__$1;
(statearr_17747_17809[(2)] = null);

(statearr_17747_17809[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (9))){
var state_17717__$1 = state_17717;
var statearr_17748_17810 = state_17717__$1;
(statearr_17748_17810[(2)] = null);

(statearr_17748_17810[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (5))){
var state_17717__$1 = state_17717;
var statearr_17749_17811 = state_17717__$1;
(statearr_17749_17811[(2)] = null);

(statearr_17749_17811[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (10))){
var inst_17709 = (state_17717[(2)]);
var state_17717__$1 = state_17717;
var statearr_17750_17815 = state_17717__$1;
(statearr_17750_17815[(2)] = inst_17709);

(statearr_17750_17815[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17718 === (8))){
var inst_17699 = (state_17717[(7)]);
var state_17717__$1 = state_17717;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17717__$1,(11),out,inst_17699);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___17762,out))
;
return ((function (switch__13813__auto__,c__13836__auto___17762,out){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_17754 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_17754[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_17754[(1)] = (1));

return statearr_17754;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_17717){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_17717);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e17755){if((e17755 instanceof Object)){
var ex__13817__auto__ = e17755;
var statearr_17756_17819 = state_17717;
(statearr_17756_17819[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17717);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17755;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17820 = state_17717;
state_17717 = G__17820;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_17717){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_17717);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___17762,out))
})();
var state__13838__auto__ = (function (){var statearr_17757 = f__13837__auto__.call(null);
(statearr_17757[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___17762);

return statearr_17757;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___17762,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async17840 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17840 = (function (f,ch,meta17841){
this.f = f;
this.ch = ch;
this.meta17841 = meta17841;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17842,meta17841__$1){
var self__ = this;
var _17842__$1 = this;
return (new cljs.core.async.t_cljs$core$async17840(self__.f,self__.ch,meta17841__$1));
});

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17842){
var self__ = this;
var _17842__$1 = this;
return self__.meta17841;
});

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async17843 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17843 = (function (f,ch,meta17841,_,fn1,meta17844){
this.f = f;
this.ch = ch;
this.meta17841 = meta17841;
this._ = _;
this.fn1 = fn1;
this.meta17844 = meta17844;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17843.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_17845,meta17844__$1){
var self__ = this;
var _17845__$1 = this;
return (new cljs.core.async.t_cljs$core$async17843(self__.f,self__.ch,self__.meta17841,self__._,self__.fn1,meta17844__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async17843.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_17845){
var self__ = this;
var _17845__$1 = this;
return self__.meta17844;
});})(___$1))
;

cljs.core.async.t_cljs$core$async17843.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17843.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async17843.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async17843.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__17827_SHARP_){
return f1.call(null,(((p1__17827_SHARP_ == null))?null:self__.f.call(null,p1__17827_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async17843.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17841","meta17841",954741610,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async17840","cljs.core.async/t_cljs$core$async17840",-1467100337,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta17844","meta17844",-475768663,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async17843.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17843.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17843";

cljs.core.async.t_cljs$core$async17843.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17843");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async17843 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async17843(f__$1,ch__$1,meta17841__$1,___$2,fn1__$1,meta17844){
return (new cljs.core.async.t_cljs$core$async17843(f__$1,ch__$1,meta17841__$1,___$2,fn1__$1,meta17844));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async17843(self__.f,self__.ch,self__.meta17841,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__6531__auto__ = ret;
if(cljs.core.truth_(and__6531__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__6531__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17840.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async17840.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17841","meta17841",954741610,null)], null);
});

cljs.core.async.t_cljs$core$async17840.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17840.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17840";

cljs.core.async.t_cljs$core$async17840.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17840");
});

cljs.core.async.__GT_t_cljs$core$async17840 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async17840(f__$1,ch__$1,meta17841){
return (new cljs.core.async.t_cljs$core$async17840(f__$1,ch__$1,meta17841));
});

}

return (new cljs.core.async.t_cljs$core$async17840(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async17887 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17887 = (function (f,ch,meta17888){
this.f = f;
this.ch = ch;
this.meta17888 = meta17888;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17889,meta17888__$1){
var self__ = this;
var _17889__$1 = this;
return (new cljs.core.async.t_cljs$core$async17887(self__.f,self__.ch,meta17888__$1));
});

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17889){
var self__ = this;
var _17889__$1 = this;
return self__.meta17888;
});

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17887.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async17887.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17888","meta17888",1700792885,null)], null);
});

cljs.core.async.t_cljs$core$async17887.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17887.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17887";

cljs.core.async.t_cljs$core$async17887.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17887");
});

cljs.core.async.__GT_t_cljs$core$async17887 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async17887(f__$1,ch__$1,meta17888){
return (new cljs.core.async.t_cljs$core$async17887(f__$1,ch__$1,meta17888));
});

}

return (new cljs.core.async.t_cljs$core$async17887(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async17924 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17924 = (function (p,ch,meta17925){
this.p = p;
this.ch = ch;
this.meta17925 = meta17925;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17926,meta17925__$1){
var self__ = this;
var _17926__$1 = this;
return (new cljs.core.async.t_cljs$core$async17924(self__.p,self__.ch,meta17925__$1));
});

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17926){
var self__ = this;
var _17926__$1 = this;
return self__.meta17925;
});

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17924.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async17924.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17925","meta17925",1065259854,null)], null);
});

cljs.core.async.t_cljs$core$async17924.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17924.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17924";

cljs.core.async.t_cljs$core$async17924.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17924");
});

cljs.core.async.__GT_t_cljs$core$async17924 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async17924(p__$1,ch__$1,meta17925){
return (new cljs.core.async.t_cljs$core$async17924(p__$1,ch__$1,meta17925));
});

}

return (new cljs.core.async.t_cljs$core$async17924(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args17946 = [];
var len__7651__auto___18024 = arguments.length;
var i__7652__auto___18025 = (0);
while(true){
if((i__7652__auto___18025 < len__7651__auto___18024)){
args17946.push((arguments[i__7652__auto___18025]));

var G__18026 = (i__7652__auto___18025 + (1));
i__7652__auto___18025 = G__18026;
continue;
} else {
}
break;
}

var G__17962 = args17946.length;
switch (G__17962) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17946.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13836__auto___18033 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___18033,out){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___18033,out){
return (function (state_17987){
var state_val_17988 = (state_17987[(1)]);
if((state_val_17988 === (7))){
var inst_17983 = (state_17987[(2)]);
var state_17987__$1 = state_17987;
var statearr_17989_18035 = state_17987__$1;
(statearr_17989_18035[(2)] = inst_17983);

(statearr_17989_18035[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (1))){
var state_17987__$1 = state_17987;
var statearr_17990_18036 = state_17987__$1;
(statearr_17990_18036[(2)] = null);

(statearr_17990_18036[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (4))){
var inst_17969 = (state_17987[(7)]);
var inst_17969__$1 = (state_17987[(2)]);
var inst_17970 = (inst_17969__$1 == null);
var state_17987__$1 = (function (){var statearr_17991 = state_17987;
(statearr_17991[(7)] = inst_17969__$1);

return statearr_17991;
})();
if(cljs.core.truth_(inst_17970)){
var statearr_17992_18037 = state_17987__$1;
(statearr_17992_18037[(1)] = (5));

} else {
var statearr_17993_18038 = state_17987__$1;
(statearr_17993_18038[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (6))){
var inst_17969 = (state_17987[(7)]);
var inst_17974 = p.call(null,inst_17969);
var state_17987__$1 = state_17987;
if(cljs.core.truth_(inst_17974)){
var statearr_18006_18039 = state_17987__$1;
(statearr_18006_18039[(1)] = (8));

} else {
var statearr_18007_18040 = state_17987__$1;
(statearr_18007_18040[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (3))){
var inst_17985 = (state_17987[(2)]);
var state_17987__$1 = state_17987;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17987__$1,inst_17985);
} else {
if((state_val_17988 === (2))){
var state_17987__$1 = state_17987;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17987__$1,(4),ch);
} else {
if((state_val_17988 === (11))){
var inst_17977 = (state_17987[(2)]);
var state_17987__$1 = state_17987;
var statearr_18008_18041 = state_17987__$1;
(statearr_18008_18041[(2)] = inst_17977);

(statearr_18008_18041[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (9))){
var state_17987__$1 = state_17987;
var statearr_18009_18042 = state_17987__$1;
(statearr_18009_18042[(2)] = null);

(statearr_18009_18042[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (5))){
var inst_17972 = cljs.core.async.close_BANG_.call(null,out);
var state_17987__$1 = state_17987;
var statearr_18010_18043 = state_17987__$1;
(statearr_18010_18043[(2)] = inst_17972);

(statearr_18010_18043[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (10))){
var inst_17980 = (state_17987[(2)]);
var state_17987__$1 = (function (){var statearr_18011 = state_17987;
(statearr_18011[(8)] = inst_17980);

return statearr_18011;
})();
var statearr_18012_18044 = state_17987__$1;
(statearr_18012_18044[(2)] = null);

(statearr_18012_18044[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17988 === (8))){
var inst_17969 = (state_17987[(7)]);
var state_17987__$1 = state_17987;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17987__$1,(11),out,inst_17969);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___18033,out))
;
return ((function (switch__13813__auto__,c__13836__auto___18033,out){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_18016 = [null,null,null,null,null,null,null,null,null];
(statearr_18016[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_18016[(1)] = (1));

return statearr_18016;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_17987){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_17987);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e18017){if((e18017 instanceof Object)){
var ex__13817__auto__ = e18017;
var statearr_18018_18056 = state_17987;
(statearr_18018_18056[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17987);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18017;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18058 = state_17987;
state_17987 = G__18058;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_17987){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_17987);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___18033,out))
})();
var state__13838__auto__ = (function (){var statearr_18019 = f__13837__auto__.call(null);
(statearr_18019[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___18033);

return statearr_18019;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___18033,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args18059 = [];
var len__7651__auto___18062 = arguments.length;
var i__7652__auto___18063 = (0);
while(true){
if((i__7652__auto___18063 < len__7651__auto___18062)){
args18059.push((arguments[i__7652__auto___18063]));

var G__18064 = (i__7652__auto___18063 + (1));
i__7652__auto___18063 = G__18064;
continue;
} else {
}
break;
}

var G__18061 = args18059.length;
switch (G__18061) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18059.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__13836__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto__){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto__){
return (function (state_18273){
var state_val_18274 = (state_18273[(1)]);
if((state_val_18274 === (7))){
var inst_18269 = (state_18273[(2)]);
var state_18273__$1 = state_18273;
var statearr_18276_18340 = state_18273__$1;
(statearr_18276_18340[(2)] = inst_18269);

(statearr_18276_18340[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (20))){
var inst_18238 = (state_18273[(7)]);
var inst_18250 = (state_18273[(2)]);
var inst_18251 = cljs.core.next.call(null,inst_18238);
var inst_18224 = inst_18251;
var inst_18225 = null;
var inst_18226 = (0);
var inst_18227 = (0);
var state_18273__$1 = (function (){var statearr_18278 = state_18273;
(statearr_18278[(8)] = inst_18250);

(statearr_18278[(9)] = inst_18224);

(statearr_18278[(10)] = inst_18225);

(statearr_18278[(11)] = inst_18227);

(statearr_18278[(12)] = inst_18226);

return statearr_18278;
})();
var statearr_18279_18348 = state_18273__$1;
(statearr_18279_18348[(2)] = null);

(statearr_18279_18348[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (1))){
var state_18273__$1 = state_18273;
var statearr_18280_18352 = state_18273__$1;
(statearr_18280_18352[(2)] = null);

(statearr_18280_18352[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (4))){
var inst_18212 = (state_18273[(13)]);
var inst_18212__$1 = (state_18273[(2)]);
var inst_18213 = (inst_18212__$1 == null);
var state_18273__$1 = (function (){var statearr_18285 = state_18273;
(statearr_18285[(13)] = inst_18212__$1);

return statearr_18285;
})();
if(cljs.core.truth_(inst_18213)){
var statearr_18286_18353 = state_18273__$1;
(statearr_18286_18353[(1)] = (5));

} else {
var statearr_18287_18354 = state_18273__$1;
(statearr_18287_18354[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (15))){
var state_18273__$1 = state_18273;
var statearr_18291_18355 = state_18273__$1;
(statearr_18291_18355[(2)] = null);

(statearr_18291_18355[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (21))){
var state_18273__$1 = state_18273;
var statearr_18292_18356 = state_18273__$1;
(statearr_18292_18356[(2)] = null);

(statearr_18292_18356[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (13))){
var inst_18224 = (state_18273[(9)]);
var inst_18225 = (state_18273[(10)]);
var inst_18227 = (state_18273[(11)]);
var inst_18226 = (state_18273[(12)]);
var inst_18234 = (state_18273[(2)]);
var inst_18235 = (inst_18227 + (1));
var tmp18288 = inst_18224;
var tmp18289 = inst_18225;
var tmp18290 = inst_18226;
var inst_18224__$1 = tmp18288;
var inst_18225__$1 = tmp18289;
var inst_18226__$1 = tmp18290;
var inst_18227__$1 = inst_18235;
var state_18273__$1 = (function (){var statearr_18293 = state_18273;
(statearr_18293[(9)] = inst_18224__$1);

(statearr_18293[(10)] = inst_18225__$1);

(statearr_18293[(14)] = inst_18234);

(statearr_18293[(11)] = inst_18227__$1);

(statearr_18293[(12)] = inst_18226__$1);

return statearr_18293;
})();
var statearr_18294_18357 = state_18273__$1;
(statearr_18294_18357[(2)] = null);

(statearr_18294_18357[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (22))){
var state_18273__$1 = state_18273;
var statearr_18295_18358 = state_18273__$1;
(statearr_18295_18358[(2)] = null);

(statearr_18295_18358[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (6))){
var inst_18212 = (state_18273[(13)]);
var inst_18221 = f.call(null,inst_18212);
var inst_18222 = cljs.core.seq.call(null,inst_18221);
var inst_18224 = inst_18222;
var inst_18225 = null;
var inst_18226 = (0);
var inst_18227 = (0);
var state_18273__$1 = (function (){var statearr_18298 = state_18273;
(statearr_18298[(9)] = inst_18224);

(statearr_18298[(10)] = inst_18225);

(statearr_18298[(11)] = inst_18227);

(statearr_18298[(12)] = inst_18226);

return statearr_18298;
})();
var statearr_18299_18370 = state_18273__$1;
(statearr_18299_18370[(2)] = null);

(statearr_18299_18370[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (17))){
var inst_18238 = (state_18273[(7)]);
var inst_18243 = cljs.core.chunk_first.call(null,inst_18238);
var inst_18244 = cljs.core.chunk_rest.call(null,inst_18238);
var inst_18245 = cljs.core.count.call(null,inst_18243);
var inst_18224 = inst_18244;
var inst_18225 = inst_18243;
var inst_18226 = inst_18245;
var inst_18227 = (0);
var state_18273__$1 = (function (){var statearr_18302 = state_18273;
(statearr_18302[(9)] = inst_18224);

(statearr_18302[(10)] = inst_18225);

(statearr_18302[(11)] = inst_18227);

(statearr_18302[(12)] = inst_18226);

return statearr_18302;
})();
var statearr_18303_18382 = state_18273__$1;
(statearr_18303_18382[(2)] = null);

(statearr_18303_18382[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (3))){
var inst_18271 = (state_18273[(2)]);
var state_18273__$1 = state_18273;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18273__$1,inst_18271);
} else {
if((state_val_18274 === (12))){
var inst_18259 = (state_18273[(2)]);
var state_18273__$1 = state_18273;
var statearr_18304_18383 = state_18273__$1;
(statearr_18304_18383[(2)] = inst_18259);

(statearr_18304_18383[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (2))){
var state_18273__$1 = state_18273;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18273__$1,(4),in$);
} else {
if((state_val_18274 === (23))){
var inst_18267 = (state_18273[(2)]);
var state_18273__$1 = state_18273;
var statearr_18305_18395 = state_18273__$1;
(statearr_18305_18395[(2)] = inst_18267);

(statearr_18305_18395[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (19))){
var inst_18254 = (state_18273[(2)]);
var state_18273__$1 = state_18273;
var statearr_18306_18399 = state_18273__$1;
(statearr_18306_18399[(2)] = inst_18254);

(statearr_18306_18399[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (11))){
var inst_18238 = (state_18273[(7)]);
var inst_18224 = (state_18273[(9)]);
var inst_18238__$1 = cljs.core.seq.call(null,inst_18224);
var state_18273__$1 = (function (){var statearr_18307 = state_18273;
(statearr_18307[(7)] = inst_18238__$1);

return statearr_18307;
})();
if(inst_18238__$1){
var statearr_18308_18408 = state_18273__$1;
(statearr_18308_18408[(1)] = (14));

} else {
var statearr_18309_18409 = state_18273__$1;
(statearr_18309_18409[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (9))){
var inst_18261 = (state_18273[(2)]);
var inst_18262 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_18273__$1 = (function (){var statearr_18310 = state_18273;
(statearr_18310[(15)] = inst_18261);

return statearr_18310;
})();
if(cljs.core.truth_(inst_18262)){
var statearr_18311_18411 = state_18273__$1;
(statearr_18311_18411[(1)] = (21));

} else {
var statearr_18312_18415 = state_18273__$1;
(statearr_18312_18415[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (5))){
var inst_18215 = cljs.core.async.close_BANG_.call(null,out);
var state_18273__$1 = state_18273;
var statearr_18313_18420 = state_18273__$1;
(statearr_18313_18420[(2)] = inst_18215);

(statearr_18313_18420[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (14))){
var inst_18238 = (state_18273[(7)]);
var inst_18241 = cljs.core.chunked_seq_QMARK_.call(null,inst_18238);
var state_18273__$1 = state_18273;
if(inst_18241){
var statearr_18314_18421 = state_18273__$1;
(statearr_18314_18421[(1)] = (17));

} else {
var statearr_18315_18429 = state_18273__$1;
(statearr_18315_18429[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (16))){
var inst_18257 = (state_18273[(2)]);
var state_18273__$1 = state_18273;
var statearr_18316_18433 = state_18273__$1;
(statearr_18316_18433[(2)] = inst_18257);

(statearr_18316_18433[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18274 === (10))){
var inst_18225 = (state_18273[(10)]);
var inst_18227 = (state_18273[(11)]);
var inst_18232 = cljs.core._nth.call(null,inst_18225,inst_18227);
var state_18273__$1 = state_18273;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18273__$1,(13),out,inst_18232);
} else {
if((state_val_18274 === (18))){
var inst_18238 = (state_18273[(7)]);
var inst_18248 = cljs.core.first.call(null,inst_18238);
var state_18273__$1 = state_18273;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18273__$1,(20),out,inst_18248);
} else {
if((state_val_18274 === (8))){
var inst_18227 = (state_18273[(11)]);
var inst_18226 = (state_18273[(12)]);
var inst_18229 = (inst_18227 < inst_18226);
var inst_18230 = inst_18229;
var state_18273__$1 = state_18273;
if(cljs.core.truth_(inst_18230)){
var statearr_18317_18444 = state_18273__$1;
(statearr_18317_18444[(1)] = (10));

} else {
var statearr_18318_18445 = state_18273__$1;
(statearr_18318_18445[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto__))
;
return ((function (switch__13813__auto__,c__13836__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__13814__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__13814__auto____0 = (function (){
var statearr_18322 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18322[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__13814__auto__);

(statearr_18322[(1)] = (1));

return statearr_18322;
});
var cljs$core$async$mapcat_STAR__$_state_machine__13814__auto____1 = (function (state_18273){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_18273);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e18323){if((e18323 instanceof Object)){
var ex__13817__auto__ = e18323;
var statearr_18324_18450 = state_18273;
(statearr_18324_18450[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18273);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18323;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18451 = state_18273;
state_18273 = G__18451;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__13814__auto__ = function(state_18273){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__13814__auto____1.call(this,state_18273);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__13814__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__13814__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto__))
})();
var state__13838__auto__ = (function (){var statearr_18325 = f__13837__auto__.call(null);
(statearr_18325[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto__);

return statearr_18325;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto__))
);

return c__13836__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args18458 = [];
var len__7651__auto___18466 = arguments.length;
var i__7652__auto___18467 = (0);
while(true){
if((i__7652__auto___18467 < len__7651__auto___18466)){
args18458.push((arguments[i__7652__auto___18467]));

var G__18469 = (i__7652__auto___18467 + (1));
i__7652__auto___18467 = G__18469;
continue;
} else {
}
break;
}

var G__18460 = args18458.length;
switch (G__18460) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18458.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args18484 = [];
var len__7651__auto___18491 = arguments.length;
var i__7652__auto___18492 = (0);
while(true){
if((i__7652__auto___18492 < len__7651__auto___18491)){
args18484.push((arguments[i__7652__auto___18492]));

var G__18493 = (i__7652__auto___18492 + (1));
i__7652__auto___18492 = G__18493;
continue;
} else {
}
break;
}

var G__18489 = args18484.length;
switch (G__18489) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18484.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args18510 = [];
var len__7651__auto___18598 = arguments.length;
var i__7652__auto___18599 = (0);
while(true){
if((i__7652__auto___18599 < len__7651__auto___18598)){
args18510.push((arguments[i__7652__auto___18599]));

var G__18600 = (i__7652__auto___18599 + (1));
i__7652__auto___18599 = G__18600;
continue;
} else {
}
break;
}

var G__18513 = args18510.length;
switch (G__18513) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18510.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13836__auto___18602 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___18602,out){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___18602,out){
return (function (state_18551){
var state_val_18552 = (state_18551[(1)]);
if((state_val_18552 === (7))){
var inst_18543 = (state_18551[(2)]);
var state_18551__$1 = state_18551;
var statearr_18553_18605 = state_18551__$1;
(statearr_18553_18605[(2)] = inst_18543);

(statearr_18553_18605[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (1))){
var inst_18525 = null;
var state_18551__$1 = (function (){var statearr_18554 = state_18551;
(statearr_18554[(7)] = inst_18525);

return statearr_18554;
})();
var statearr_18555_18606 = state_18551__$1;
(statearr_18555_18606[(2)] = null);

(statearr_18555_18606[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (4))){
var inst_18528 = (state_18551[(8)]);
var inst_18528__$1 = (state_18551[(2)]);
var inst_18529 = (inst_18528__$1 == null);
var inst_18530 = cljs.core.not.call(null,inst_18529);
var state_18551__$1 = (function (){var statearr_18556 = state_18551;
(statearr_18556[(8)] = inst_18528__$1);

return statearr_18556;
})();
if(inst_18530){
var statearr_18561_18607 = state_18551__$1;
(statearr_18561_18607[(1)] = (5));

} else {
var statearr_18562_18608 = state_18551__$1;
(statearr_18562_18608[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (6))){
var state_18551__$1 = state_18551;
var statearr_18563_18609 = state_18551__$1;
(statearr_18563_18609[(2)] = null);

(statearr_18563_18609[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (3))){
var inst_18545 = (state_18551[(2)]);
var inst_18546 = cljs.core.async.close_BANG_.call(null,out);
var state_18551__$1 = (function (){var statearr_18564 = state_18551;
(statearr_18564[(9)] = inst_18545);

return statearr_18564;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18551__$1,inst_18546);
} else {
if((state_val_18552 === (2))){
var state_18551__$1 = state_18551;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18551__$1,(4),ch);
} else {
if((state_val_18552 === (11))){
var inst_18528 = (state_18551[(8)]);
var inst_18537 = (state_18551[(2)]);
var inst_18525 = inst_18528;
var state_18551__$1 = (function (){var statearr_18565 = state_18551;
(statearr_18565[(7)] = inst_18525);

(statearr_18565[(10)] = inst_18537);

return statearr_18565;
})();
var statearr_18566_18657 = state_18551__$1;
(statearr_18566_18657[(2)] = null);

(statearr_18566_18657[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (9))){
var inst_18528 = (state_18551[(8)]);
var state_18551__$1 = state_18551;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18551__$1,(11),out,inst_18528);
} else {
if((state_val_18552 === (5))){
var inst_18525 = (state_18551[(7)]);
var inst_18528 = (state_18551[(8)]);
var inst_18532 = cljs.core._EQ_.call(null,inst_18528,inst_18525);
var state_18551__$1 = state_18551;
if(inst_18532){
var statearr_18574_18661 = state_18551__$1;
(statearr_18574_18661[(1)] = (8));

} else {
var statearr_18578_18662 = state_18551__$1;
(statearr_18578_18662[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (10))){
var inst_18540 = (state_18551[(2)]);
var state_18551__$1 = state_18551;
var statearr_18579_18663 = state_18551__$1;
(statearr_18579_18663[(2)] = inst_18540);

(statearr_18579_18663[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18552 === (8))){
var inst_18525 = (state_18551[(7)]);
var tmp18570 = inst_18525;
var inst_18525__$1 = tmp18570;
var state_18551__$1 = (function (){var statearr_18580 = state_18551;
(statearr_18580[(7)] = inst_18525__$1);

return statearr_18580;
})();
var statearr_18581_18664 = state_18551__$1;
(statearr_18581_18664[(2)] = null);

(statearr_18581_18664[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___18602,out))
;
return ((function (switch__13813__auto__,c__13836__auto___18602,out){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_18592 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_18592[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_18592[(1)] = (1));

return statearr_18592;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_18551){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_18551);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e18593){if((e18593 instanceof Object)){
var ex__13817__auto__ = e18593;
var statearr_18594_18665 = state_18551;
(statearr_18594_18665[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18551);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18593;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18669 = state_18551;
state_18551 = G__18669;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_18551){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_18551);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___18602,out))
})();
var state__13838__auto__ = (function (){var statearr_18597 = f__13837__auto__.call(null);
(statearr_18597[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___18602);

return statearr_18597;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___18602,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args18670 = [];
var len__7651__auto___18764 = arguments.length;
var i__7652__auto___18765 = (0);
while(true){
if((i__7652__auto___18765 < len__7651__auto___18764)){
args18670.push((arguments[i__7652__auto___18765]));

var G__18766 = (i__7652__auto___18765 + (1));
i__7652__auto___18765 = G__18766;
continue;
} else {
}
break;
}

var G__18672 = args18670.length;
switch (G__18672) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18670.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13836__auto___18768 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___18768,out){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___18768,out){
return (function (state_18710){
var state_val_18711 = (state_18710[(1)]);
if((state_val_18711 === (7))){
var inst_18706 = (state_18710[(2)]);
var state_18710__$1 = state_18710;
var statearr_18712_18769 = state_18710__$1;
(statearr_18712_18769[(2)] = inst_18706);

(statearr_18712_18769[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (1))){
var inst_18673 = (new Array(n));
var inst_18674 = inst_18673;
var inst_18675 = (0);
var state_18710__$1 = (function (){var statearr_18713 = state_18710;
(statearr_18713[(7)] = inst_18674);

(statearr_18713[(8)] = inst_18675);

return statearr_18713;
})();
var statearr_18714_18770 = state_18710__$1;
(statearr_18714_18770[(2)] = null);

(statearr_18714_18770[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (4))){
var inst_18678 = (state_18710[(9)]);
var inst_18678__$1 = (state_18710[(2)]);
var inst_18679 = (inst_18678__$1 == null);
var inst_18680 = cljs.core.not.call(null,inst_18679);
var state_18710__$1 = (function (){var statearr_18718 = state_18710;
(statearr_18718[(9)] = inst_18678__$1);

return statearr_18718;
})();
if(inst_18680){
var statearr_18725_18771 = state_18710__$1;
(statearr_18725_18771[(1)] = (5));

} else {
var statearr_18726_18772 = state_18710__$1;
(statearr_18726_18772[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (15))){
var inst_18700 = (state_18710[(2)]);
var state_18710__$1 = state_18710;
var statearr_18727_18776 = state_18710__$1;
(statearr_18727_18776[(2)] = inst_18700);

(statearr_18727_18776[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (13))){
var state_18710__$1 = state_18710;
var statearr_18728_18780 = state_18710__$1;
(statearr_18728_18780[(2)] = null);

(statearr_18728_18780[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (6))){
var inst_18675 = (state_18710[(8)]);
var inst_18696 = (inst_18675 > (0));
var state_18710__$1 = state_18710;
if(cljs.core.truth_(inst_18696)){
var statearr_18729_18787 = state_18710__$1;
(statearr_18729_18787[(1)] = (12));

} else {
var statearr_18730_18788 = state_18710__$1;
(statearr_18730_18788[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (3))){
var inst_18708 = (state_18710[(2)]);
var state_18710__$1 = state_18710;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18710__$1,inst_18708);
} else {
if((state_val_18711 === (12))){
var inst_18674 = (state_18710[(7)]);
var inst_18698 = cljs.core.vec.call(null,inst_18674);
var state_18710__$1 = state_18710;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18710__$1,(15),out,inst_18698);
} else {
if((state_val_18711 === (2))){
var state_18710__$1 = state_18710;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18710__$1,(4),ch);
} else {
if((state_val_18711 === (11))){
var inst_18690 = (state_18710[(2)]);
var inst_18691 = (new Array(n));
var inst_18674 = inst_18691;
var inst_18675 = (0);
var state_18710__$1 = (function (){var statearr_18731 = state_18710;
(statearr_18731[(7)] = inst_18674);

(statearr_18731[(8)] = inst_18675);

(statearr_18731[(10)] = inst_18690);

return statearr_18731;
})();
var statearr_18732_18794 = state_18710__$1;
(statearr_18732_18794[(2)] = null);

(statearr_18732_18794[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (9))){
var inst_18674 = (state_18710[(7)]);
var inst_18688 = cljs.core.vec.call(null,inst_18674);
var state_18710__$1 = state_18710;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18710__$1,(11),out,inst_18688);
} else {
if((state_val_18711 === (5))){
var inst_18678 = (state_18710[(9)]);
var inst_18674 = (state_18710[(7)]);
var inst_18683 = (state_18710[(11)]);
var inst_18675 = (state_18710[(8)]);
var inst_18682 = (inst_18674[inst_18675] = inst_18678);
var inst_18683__$1 = (inst_18675 + (1));
var inst_18684 = (inst_18683__$1 < n);
var state_18710__$1 = (function (){var statearr_18733 = state_18710;
(statearr_18733[(11)] = inst_18683__$1);

(statearr_18733[(12)] = inst_18682);

return statearr_18733;
})();
if(cljs.core.truth_(inst_18684)){
var statearr_18734_18798 = state_18710__$1;
(statearr_18734_18798[(1)] = (8));

} else {
var statearr_18736_18799 = state_18710__$1;
(statearr_18736_18799[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (14))){
var inst_18703 = (state_18710[(2)]);
var inst_18704 = cljs.core.async.close_BANG_.call(null,out);
var state_18710__$1 = (function (){var statearr_18742 = state_18710;
(statearr_18742[(13)] = inst_18703);

return statearr_18742;
})();
var statearr_18743_18800 = state_18710__$1;
(statearr_18743_18800[(2)] = inst_18704);

(statearr_18743_18800[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (10))){
var inst_18694 = (state_18710[(2)]);
var state_18710__$1 = state_18710;
var statearr_18744_18801 = state_18710__$1;
(statearr_18744_18801[(2)] = inst_18694);

(statearr_18744_18801[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18711 === (8))){
var inst_18674 = (state_18710[(7)]);
var inst_18683 = (state_18710[(11)]);
var tmp18737 = inst_18674;
var inst_18674__$1 = tmp18737;
var inst_18675 = inst_18683;
var state_18710__$1 = (function (){var statearr_18745 = state_18710;
(statearr_18745[(7)] = inst_18674__$1);

(statearr_18745[(8)] = inst_18675);

return statearr_18745;
})();
var statearr_18746_18802 = state_18710__$1;
(statearr_18746_18802[(2)] = null);

(statearr_18746_18802[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___18768,out))
;
return ((function (switch__13813__auto__,c__13836__auto___18768,out){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_18750 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18750[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_18750[(1)] = (1));

return statearr_18750;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_18710){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_18710);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e18751){if((e18751 instanceof Object)){
var ex__13817__auto__ = e18751;
var statearr_18755_18809 = state_18710;
(statearr_18755_18809[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18710);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18751;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18813 = state_18710;
state_18710 = G__18813;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_18710){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_18710);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___18768,out))
})();
var state__13838__auto__ = (function (){var statearr_18759 = f__13837__auto__.call(null);
(statearr_18759[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___18768);

return statearr_18759;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___18768,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args18817 = [];
var len__7651__auto___18930 = arguments.length;
var i__7652__auto___18931 = (0);
while(true){
if((i__7652__auto___18931 < len__7651__auto___18930)){
args18817.push((arguments[i__7652__auto___18931]));

var G__18932 = (i__7652__auto___18931 + (1));
i__7652__auto___18931 = G__18932;
continue;
} else {
}
break;
}

var G__18827 = args18817.length;
switch (G__18827) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18817.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13836__auto___18934 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13836__auto___18934,out){
return (function (){
var f__13837__auto__ = (function (){var switch__13813__auto__ = ((function (c__13836__auto___18934,out){
return (function (state_18872){
var state_val_18873 = (state_18872[(1)]);
if((state_val_18873 === (7))){
var inst_18868 = (state_18872[(2)]);
var state_18872__$1 = state_18872;
var statearr_18875_18935 = state_18872__$1;
(statearr_18875_18935[(2)] = inst_18868);

(statearr_18875_18935[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (1))){
var inst_18831 = [];
var inst_18832 = inst_18831;
var inst_18833 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_18872__$1 = (function (){var statearr_18876 = state_18872;
(statearr_18876[(7)] = inst_18833);

(statearr_18876[(8)] = inst_18832);

return statearr_18876;
})();
var statearr_18878_18936 = state_18872__$1;
(statearr_18878_18936[(2)] = null);

(statearr_18878_18936[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (4))){
var inst_18836 = (state_18872[(9)]);
var inst_18836__$1 = (state_18872[(2)]);
var inst_18837 = (inst_18836__$1 == null);
var inst_18838 = cljs.core.not.call(null,inst_18837);
var state_18872__$1 = (function (){var statearr_18884 = state_18872;
(statearr_18884[(9)] = inst_18836__$1);

return statearr_18884;
})();
if(inst_18838){
var statearr_18885_18939 = state_18872__$1;
(statearr_18885_18939[(1)] = (5));

} else {
var statearr_18886_18940 = state_18872__$1;
(statearr_18886_18940[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (15))){
var inst_18862 = (state_18872[(2)]);
var state_18872__$1 = state_18872;
var statearr_18888_18941 = state_18872__$1;
(statearr_18888_18941[(2)] = inst_18862);

(statearr_18888_18941[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (13))){
var state_18872__$1 = state_18872;
var statearr_18889_18942 = state_18872__$1;
(statearr_18889_18942[(2)] = null);

(statearr_18889_18942[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (6))){
var inst_18832 = (state_18872[(8)]);
var inst_18857 = inst_18832.length;
var inst_18858 = (inst_18857 > (0));
var state_18872__$1 = state_18872;
if(cljs.core.truth_(inst_18858)){
var statearr_18897_18943 = state_18872__$1;
(statearr_18897_18943[(1)] = (12));

} else {
var statearr_18898_18944 = state_18872__$1;
(statearr_18898_18944[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (3))){
var inst_18870 = (state_18872[(2)]);
var state_18872__$1 = state_18872;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18872__$1,inst_18870);
} else {
if((state_val_18873 === (12))){
var inst_18832 = (state_18872[(8)]);
var inst_18860 = cljs.core.vec.call(null,inst_18832);
var state_18872__$1 = state_18872;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18872__$1,(15),out,inst_18860);
} else {
if((state_val_18873 === (2))){
var state_18872__$1 = state_18872;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18872__$1,(4),ch);
} else {
if((state_val_18873 === (11))){
var inst_18836 = (state_18872[(9)]);
var inst_18840 = (state_18872[(10)]);
var inst_18850 = (state_18872[(2)]);
var inst_18851 = [];
var inst_18852 = inst_18851.push(inst_18836);
var inst_18832 = inst_18851;
var inst_18833 = inst_18840;
var state_18872__$1 = (function (){var statearr_18903 = state_18872;
(statearr_18903[(11)] = inst_18852);

(statearr_18903[(12)] = inst_18850);

(statearr_18903[(7)] = inst_18833);

(statearr_18903[(8)] = inst_18832);

return statearr_18903;
})();
var statearr_18904_18945 = state_18872__$1;
(statearr_18904_18945[(2)] = null);

(statearr_18904_18945[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (9))){
var inst_18832 = (state_18872[(8)]);
var inst_18848 = cljs.core.vec.call(null,inst_18832);
var state_18872__$1 = state_18872;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18872__$1,(11),out,inst_18848);
} else {
if((state_val_18873 === (5))){
var inst_18836 = (state_18872[(9)]);
var inst_18840 = (state_18872[(10)]);
var inst_18833 = (state_18872[(7)]);
var inst_18840__$1 = f.call(null,inst_18836);
var inst_18841 = cljs.core._EQ_.call(null,inst_18840__$1,inst_18833);
var inst_18842 = cljs.core.keyword_identical_QMARK_.call(null,inst_18833,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_18843 = (inst_18841) || (inst_18842);
var state_18872__$1 = (function (){var statearr_18905 = state_18872;
(statearr_18905[(10)] = inst_18840__$1);

return statearr_18905;
})();
if(cljs.core.truth_(inst_18843)){
var statearr_18906_18957 = state_18872__$1;
(statearr_18906_18957[(1)] = (8));

} else {
var statearr_18907_18958 = state_18872__$1;
(statearr_18907_18958[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (14))){
var inst_18865 = (state_18872[(2)]);
var inst_18866 = cljs.core.async.close_BANG_.call(null,out);
var state_18872__$1 = (function (){var statearr_18909 = state_18872;
(statearr_18909[(13)] = inst_18865);

return statearr_18909;
})();
var statearr_18910_18963 = state_18872__$1;
(statearr_18910_18963[(2)] = inst_18866);

(statearr_18910_18963[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (10))){
var inst_18855 = (state_18872[(2)]);
var state_18872__$1 = state_18872;
var statearr_18911_18970 = state_18872__$1;
(statearr_18911_18970[(2)] = inst_18855);

(statearr_18911_18970[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18873 === (8))){
var inst_18836 = (state_18872[(9)]);
var inst_18840 = (state_18872[(10)]);
var inst_18832 = (state_18872[(8)]);
var inst_18845 = inst_18832.push(inst_18836);
var tmp18908 = inst_18832;
var inst_18832__$1 = tmp18908;
var inst_18833 = inst_18840;
var state_18872__$1 = (function (){var statearr_18916 = state_18872;
(statearr_18916[(14)] = inst_18845);

(statearr_18916[(7)] = inst_18833);

(statearr_18916[(8)] = inst_18832__$1);

return statearr_18916;
})();
var statearr_18917_18971 = state_18872__$1;
(statearr_18917_18971[(2)] = null);

(statearr_18917_18971[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13836__auto___18934,out))
;
return ((function (switch__13813__auto__,c__13836__auto___18934,out){
return (function() {
var cljs$core$async$state_machine__13814__auto__ = null;
var cljs$core$async$state_machine__13814__auto____0 = (function (){
var statearr_18926 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18926[(0)] = cljs$core$async$state_machine__13814__auto__);

(statearr_18926[(1)] = (1));

return statearr_18926;
});
var cljs$core$async$state_machine__13814__auto____1 = (function (state_18872){
while(true){
var ret_value__13815__auto__ = (function (){try{while(true){
var result__13816__auto__ = switch__13813__auto__.call(null,state_18872);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13816__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13816__auto__;
}
break;
}
}catch (e18927){if((e18927 instanceof Object)){
var ex__13817__auto__ = e18927;
var statearr_18928_18983 = state_18872;
(statearr_18928_18983[(5)] = ex__13817__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18872);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18927;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13815__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18987 = state_18872;
state_18872 = G__18987;
continue;
} else {
return ret_value__13815__auto__;
}
break;
}
});
cljs$core$async$state_machine__13814__auto__ = function(state_18872){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13814__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13814__auto____1.call(this,state_18872);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13814__auto____0;
cljs$core$async$state_machine__13814__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13814__auto____1;
return cljs$core$async$state_machine__13814__auto__;
})()
;})(switch__13813__auto__,c__13836__auto___18934,out))
})();
var state__13838__auto__ = (function (){var statearr_18929 = f__13837__auto__.call(null);
(statearr_18929[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13836__auto___18934);

return statearr_18929;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13838__auto__);
});})(c__13836__auto___18934,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

